/*
 @preserve Leaflet Data Visualization Framework, a JavaScript library for creating thematic maps using Leaflet
 (c) 2013, Scott Fairgrieve, HumanGeo
*/
L.LinearFunction=L.Class.extend({initialize:function(t,i,n){this.setOptions(n),this.setRange(t,i)},_calculateParameters:function(t,i){0===this._xRange?(this._slope=0,this._b=t.y):(this._slope=(i.y-t.y)/this._xRange,this._b=t.y-this._slope*t.x)},_arrayToPoint:function(t){return{x:t[0],y:t[1]}},setOptions:function(t){L.Util.setOptions(this,t),this._preProcess=this.options.preProcess,this._postProcess=this.options.postProcess},getBounds:function(){var t=Math.min(this._minPoint.x,this._maxPoint.x),i=Math.max(this._minPoint.x,this._maxPoint.x),n=Math.min(this._minPoint.y,this._maxPoint.y),e=Math.max(this._minPoint.y,this._maxPoint.y);return[new L.Point(t,n),new L.Point(i,e)]},setRange:function(t,i){return t=t instanceof Array?this._arrayToPoint(t):t,i=i instanceof Array?this._arrayToPoint(i):i,this._minPoint=t,this._maxPoint=i,this._xRange=i.x-t.x,this._calculateParameters(t,i),this},setMin:function(t){return this.setRange(t,this._maxPoint),this},setMax:function(t){return this.setRange(this._minPoint,t),this},setPreProcess:function(t){return this._preProcess=t,this},setPostProcess:function(t){return this._postProcess=t,this},evaluate:function(t){var i;return this._preProcess&&(t=this._preProcess(t)),i=Number((this._slope*t).toFixed(6))+Number(this._b.toFixed(6)),this._postProcess&&(i=this._postProcess(i)),i},random:function(){var t=Math.random()*this._xRange+this._minPoint.x;return this.evaluate(t)},sample:function(t){t=Math.max(t,2);for(var i=t-1,n=this._xRange/i,e=this._minPoint.x,o=[];this._maxPoint.x>=e;)o.push(this.evaluate(e)),e+=n;return o},samplePoints:function(t){t=Math.max(t,2);for(var i=t-1,n=this._xRange/i,e=this._minPoint.x,o=[];this._maxPoint.x>=e;)o.push(new L.Point(e,this.evaluate(e))),e+=n;return o}}),L.ColorFunction=L.LinearFunction.extend({options:{alpha:1,includeAlpha:!1},initialize:function(t,i,n){L.Util.setOptions(this,n),this._parts=[],this._dynamicPart=null,this._outputPrecision=0,this._prefix=null,this._formatOutput=function(t){return t.toFixed(this._outputPrecision)},this._mapOutput=function(t){for(var i=[],n=0;this._parts.length>n;++n){var e=this._parts[n];i.push(t[e])}return this.options.includeAlpha&&i.push(this.options.alpha),i},this._getColorString=function(t){t=this._formatOutput(t),this.options[this._dynamicPart]=t;var i=this._mapOutput(this.options);return this._writeColor(this._prefix,i)},this._writeColor=function(t,i){return this.options.includeAlpha&&(t+="a"),t+"("+i.join(",")+")"};var e=function(t){n&&n.postProcess&&(t=n.postProcess.call(this,t));var i=this._getColorString(t);return(L.Browser.ie6||L.Browser.ie7)&&i.indexOf("hsl")>-1&&(i=L.ColorUtils.hslStringToRgbString(i)),i};L.LinearFunction.prototype.initialize.call(this,t,i,{preProcess:this.options.preProcess,postProcess:e})}}),L.HSLColorFunction=L.ColorFunction.extend({initialize:function(t,i,n){L.ColorFunction.prototype.initialize.call(this,t,i,n),this._parts=["outputHue","outputSaturation","outputLuminosity"],this._prefix="hsl",this._outputPrecision=2}}),L.RGBColorFunction=L.ColorFunction.extend({initialize:function(t,i,n){L.ColorFunction.prototype.initialize.call(this,t,i,n),this._parts=["outputRed","outputBlue","outputGreen"],this._prefix="rgb",this._outputPrecision=0}}),L.RGBRedFunction=L.LinearFunction.extend({options:{outputGreen:0,outputBlue:0},initialize:function(t,i,n){L.RGBColorFunction.prototype.initialize.call(this,t,i,n),this._dynamicPart="outputRed"}}),L.RGBBlueFunction=L.LinearFunction.extend({options:{outputRed:0,outputGreen:0},initialize:function(t,i,n){L.RGBColorFunction.prototype.initialize.call(this,t,i,n),this._dynamicPart="outputBlue"}}),L.RGBGreenFunction=L.LinearFunction.extend({options:{outputRed:0,outputBlue:0},initialize:function(t,i,n){L.RGBColorFunction.prototype.initialize.call(this,t,i,n),this._dynamicPart="outputGreen"}}),L.RGBColorBlendFunction=L.LinearFunction.extend({initialize:function(t,i,n,e){var o=n[0],s=e[0],r=n[1],a=e[1],l=n[2],u=e[2],h=function(t){return t.toFixed(0)};this._minX=t,this._maxX=i,this._redFunction=new L.LinearFunction(new L.Point(t,o),new L.Point(i,s),{postProcess:h}),this._greenFunction=new L.LinearFunction(new L.Point(t,r),new L.Point(i,a),{postProcess:h}),this._blueFunction=new L.LinearFunction(new L.Point(t,l),new L.Point(i,u),{postProcess:h})},getBounds:function(){var t=this._redFunction.getBounds(),i=this._greenFunction.getBounds(),n=this._blueFunction.getBounds(),e=Math.min(t[0].y,i[0].y,n[0].y),o=Math.max(t[0].y,i[0].y,n[0].y);return[new L.Point(t[0].x,e),new L.Point(t[1].x,o)]},evaluate:function(t){return"rgb("+[this._redFunction.evaluate(t),this._greenFunction.evaluate(t),this._blueFunction.evaluate(t)].join(",")+")"}}),L.HSLHueFunction=L.HSLColorFunction.extend({options:{outputSaturation:"100%",outputLuminosity:"50%"},initialize:function(t,i,n){L.HSLColorFunction.prototype.initialize.call(this,t,i,n),this._dynamicPart="outputHue"}}),L.HSLSaturationFunction=L.LinearFunction.extend({options:{outputHue:0,outputLuminosity:"50%"},initialize:function(t,i,n){L.HSLColorFunction.prototype.initialize.call(this,t,i,n),this._formatOutput=function(t){return(100*t).toFixed(this._outputPrecision)+"%"},this._dynamicPart="outputSaturation"}}),L.HSLLuminosityFunction=L.LinearFunction.extend({options:{outputHue:0,outputSaturation:"100%"},initialize:function(t,i,n){L.HSLColorFunction.prototype.initialize.call(this,t,i,n),this._formatOutput=function(t){return(100*t).toFixed(this._outputPrecision)+"%"},this._dynamicPart="outputLuminosity"}}),L.PiecewiseFunction=L.LinearFunction.extend({initialize:function(t,i){L.Util.setOptions(this,i),this._functions=t;var n,e;n=t[0].getBounds()[0],e=t[t.length-1].getBounds()[1],L.LinearFunction.prototype.initialize.call(this,n,e,{preProcess:this.options.preProcess,postProcess:this.options.postProcess})},_getFunction:function(t){for(var i,n,e,o,s=!1,r=0;this._functions.length>r;++r)if(o=this._functions[r],i=o.getBounds(),n=i[0],e=i[1],t>=n.x&&e.x>t){s=!0;break}return s?o:this._functions[this._functions.length-1]},evaluate:function(t){var i,n=null;return this._preProcess&&(t=this._preProcess(t)),i=this._getFunction(t),i&&(n=i.evaluate(t),this._postProcess&&(n=this._postProcess(n))),n}}),L.CategoryFunction=L.Class.extend({initialize:function(t,i){L.Util.setOptions(this,i),this._categoryKeys=Object.keys(t),this._categoryMap=t,this._preProcess=this.options.preProcess,this._postProcess=this.options.postProcess},evaluate:function(t){var i;return this._preProcess&&(t=this._preProcess(t)),i=this._categoryMap[t],this._postProcess&&(i=this._postProcess(i)),i},getCategories:function(){return this._categoryKeys}}),Object.keys||(Object.keys=function(){var t=Object.prototype.hasOwnProperty,i=!{toString:null}.propertyIsEnumerable("toString"),n=["toString","toLocaleString","valueOf","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","constructor"],e=n.length;return function(o){var s,r,a;if("object"!=typeof o&&"function"!=typeof o||null===o)throw new TypeError("Object.keys called on non-object");s=[];for(r in o)t.call(o,r)&&s.push(r);if(i)for(a=0;e>a;a++)t.call(o,n[a])&&s.push(n[a]);return s}}()),L.Util.guid=function(){var t=function(){return Math.floor(65536*(1+Math.random())).toString(16).substring(1)};return t()+t()+"-"+t()+"-"+t()+"-"+t()+"-"+t()+t()+t()},L.Util.getProperty=function(t,i,n){return i in t?t[i]:n},L.Util.setFieldValue=function(t,i,n){for(var e,o=i.split("."),s=t,r=0;o.length-1>r;++r)e=o[r],s[e]=s[e]||{},s=s[e];s[o[o.length-1]]=n},L.Util.getFieldValue=function(t,i){var n=null;if(i){for(var e,o,s,r,a,l,u,h=i.split("."),p=t,c=-1,d=0;h.length>d;++d)if(e=h[d],c=e.indexOf("["),c>-1){l=e.substring(c),e=e.substring(0,c),l=l.replace("[","").replace("]",""),o=l.split("="),s=o[0],r=o[1],p=p[e];for(var f=0;p.length>f;++f)a=p[f],u=a[s],u&&u===r&&(p=a)}else{if(!p||!p.hasOwnProperty(e)){p=null;break}p=p[e]}n=p}else n=t;return n},L.CategoryLegend=L.Class.extend({initialize:function(t){L.Util.setOptions(this,t)},generate:function(t){t=t||{};var i='<div class="legend"></div>',n=$(i),e=t.className,o=this.options;e&&n.addClass(e),t.title&&n.append('<div class="legend-title">'+t.title+"</div>");for(var s in o){categoryOptions=o[s];var r=categoryOptions.displayName||s,a=$('<div class="data-layer-legend"><div class="legend-box"></div><div class="key">'+r+"</div></div>"),l=a.find(".legend-box");L.StyleConverter.applySVGStyle(l,categoryOptions),n.append(a)}return n.wrap("<div/>").parent().html()}}),L.LegendIcon=L.DivIcon.extend({initialize:function(t,i,n){var e,o='<div class="legend-content"><div class="title"></div><div class="legend-box"></div><div class="legend-values"></div></div>',s=$(o),r=s.find(".legend-box"),a=s.find(".legend-values"),l=i.title||i.name;l&&s.find(".title").text(l);for(var u in t){e=t[u];var h=e.name||u,p=e.value;a.append('<div class="key">'+h+'</div><div class="value">'+p+"</div>")}L.StyleConverter.applySVGStyle(r,i),r.height(5),o=s.wrap("<div>").parent().html(),n.html=o,n.className=n.className||"legend-icon",L.DivIcon.prototype.initialize.call(this,n)}}),L.legendIcon=function(t,i,n){return new L.LegendIcon(t,i,n)},L.GeometryUtils={getName:function(t){var i=null;if(t&&t.features)for(var n=0;t.features.length>n;++n){var e=t.features[n];if(e.properties&&e.properties.name){i=e.properties.name;break}}return i},getGeoJSONLocation:function(t,i,n,e){var o=new L.GeoJSON(t,{pointToLayer:function(t,o){var s={location:o,text:n?L.Util.getFieldValue(i,n):[o.lat.toFixed(3),o.lng.toFixed(3)].join(", "),center:o};return e(s,i)}}),s=null;try{s=L.GeometryUtils.loadCentroid(t)}catch(r){console.log("Error loading centroid for "+JSON.stringify(t))}return{location:o,text:n?L.Util.getFieldValue(i,n):null,center:s}},mergeProperties:function(t,i,n){var e,o,s=i.features,r=L.GeometryUtils.indexFeatureCollection(s,n),a={type:"FeatureCollection",features:[]};for(var l in t)if(t.hasOwnProperty(l)&&(e=t[l],o=e[n])){var u=r[o];for(var h in e)u.properties[h]=e[h];a.features.push(u)}return a},indexFeatureCollection:function(t,i){for(var n,e,o,s=t.features,r={},a=0;s.length>a;++a)n=s[a],e=n.properties,o=e[i],r[o]=n;return r},arrayToMap:function(t,i,n){for(var e,o,s,r={},a=0;t.length>a;++a)e=t[a],o=e[i],s=n?e[n]:e,r[o]=s;return r},arrayToMaps:function(t,i){for(var n,e,o,s,r,a,l,u=[],h=0;i.length>h;++h)u.push({});for(var p=0;t.length>p;++p){e=t[p];for(var c=0;i.length>c;++c)n=u[c],r=i[c],a=r.from,l=r.to,o=e[a],s=l?e[l]:e,n[o]=s}return u},loadCentroid:function(t){var i,n,e,o=null;if(t.geometry&&"Point"===t.geometry.type)o=new L.LatLng(t.geometry.coordinates[1],t.geometry.coordinates[0]);else if("undefined"!=typeof jsts){var s=new jsts.io.GeoJSONParser,r=s.read(t);if(r.getCentroid)i=r.getCentroid(),n=i.coordinate.x,e=i.coordinate.y;else if(r.features){for(var a=0,l=0,u=0;r.features.length>u;++u)i=r.features[u].geometry.getCentroid(),a+=i.coordinate.x,l+=i.coordinate.y;n=a/r.features.length,e=l/r.features.length}else i=r.geometry.getCentroid(),n=i.coordinate.x,e=i.coordinate.y;o=new L.LatLng(e,n)}return o},loadCentroids:function(t){var i,n={};for(var e in t)i=t[e],n[e]=L.GeometryUtils.loadCentroid(i);return n}},L.SVGPathBuilder=L.Class.extend({initialize:function(t,i,n){this._points=t||[],this._innerPoints=i||[],L.Util.setOptions(this,n)},options:{closePath:!0},_getPathString:function(t,i){var n="";if(t.length>0){var e=t[0],i=null!==i?i:2,o="M",s="L",r="Z";L.Browser.vml&&(i=0,o="m",s="|",r="xe"),n=o+e.x.toFixed(i)+","+e.y.toFixed(i);for(var a=1;t.length>a;a++)e=t[a],n+=s+e.x.toFixed(i)+","+e.y.toFixed(i);this.options.closePath&&(n+=r)}return n},addPoint:function(t,i){i?this._innerPoints.push(t):this._points.push(t)},build:function(t){t=t||this.options.digits;var i=this._getPathString(this._points,t);return this._innerPoints&&(i+=this._getPathString(this._innerPoints,t)),i}}),L.StyleConverter={keyMap:{fillColor:{property:["background-color"],valueFunction:function(t){return t}},color:{property:["color","border-top-color","border-right-color","border-bottom-color","border-left-color"],valueFunction:function(t){return t}},weight:{property:["border-width"],valueFunction:function(t){return Math.ceil(t)+"px"}},stroke:{property:["border-style"],valueFunction:function(t){return t===!0?"solid":"none"}},dashArray:{property:["border-style"],valueFunction:function(t){var i="solid";return t&&(i="dashed"),i}},barThickness:{property:["height"],valueFunction:function(t){return t+"px"}},radius:{property:["height"],valueFunction:function(t){return 2*t+"px"}},fillOpacity:{property:["opacity"],valueFunction:function(t){return t}}},applySVGStyle:function(t,i,n){var e=L.StyleConverter.keyMap;n&&(e=L.Util.extend(e,n)),t.css("border-style","solid");for(var o in i)t=L.StyleConverter.setCSSProperty(t,o,i[o],e);return t},setCSSProperty:function(t,i,n,e){var e=e||L.StyleConverter.keyMap,o=e[i];if(o)for(var s=o.property,r=0;s.length>r;++r)t.css(s[r],o.valueFunction(n));return t}},L.StylesBuilder=L.Class.extend({initialize:function(t,i){this._categories=t,this._styleFunctionMap=i,this._buildStyles()},_buildStyles:function(){for(var t,i,n,e={},o=0;this._categories.length>o;++o){t=this._categories[o],e[t]={};for(var s in this._styleFunctionMap)i=this._styleFunctionMap[s],n=i.evaluate?i.evaluate(o):"function"==typeof i?i(o):i,e[t][s]=n}this._styleMap=e},getStyles:function(){return this._styleMap}}),L.PaletteBuilder=L.Class.extend({initialize:function(t){this._styleFunctionMap=t},generate:function(t){t=t||{};var i=$('<div class="palette"></div>'),n=t.count||10,e=function(t){for(var i=[],n=0;t>n;++n)i.push(n);return i}(n),o=new L.StylesBuilder(e,this._styleFunctionMap),s=o.getStyles();t.className&&i.addClass(t.className);for(var r in s){var a=$('<i class="palette-element"></i>'),l=s[r];L.StyleConverter.applySVGStyle(a,l),i.append(a)}return i.wrap("<div/>").parent().html()}}),L.HTMLUtils={buildTable:function(t,i,n){i=i||"table table-condensed table-striped table-bordered";var e='<table class="'+i+'"><thead><tr><th>Name</th><th>Value</th></tr></thead><tbody></tbody></table>',o=$(e),s=o.find("tbody");n=n||[];for(var r in t)t.hasOwnProperty(r)&&-1===$.inArray(n,r)&&($.isPlainObject(t[r])||t[r]instanceof Array?s.append("<tr><td>"+r+"</td><td>"+L.HTMLUtils.buildTable(t[r],n).wrap("<div/>").parent().html()+"</td></tr>"):s.append("<tr><td>"+r+"</td><td>"+t[r]+"</td></tr>"));return o}},L.AnimationUtils={animate:function(t,i,n,e){var o=e.delay||0,s=e.frames||30,r=e.duration||500,a={},l=e.easeFunction||function(t){return t},u=e.complete,h=r/s;for(var p in i)"color"!=p&&"fillColor"!=p&&n[p]&&(a[p]=new L.LinearFunction([0,i[p]],[s-1,n[p]]));var c={},d=0,f=function(){for(var i in a)c[i]=a[i].evaluate(d);t.options=$.extend(!0,{},t.options,c),t.redraw(),d++,h=l(h),s>d?setTimeout(f,h):u()};setTimeout(f,o)}},L.ColorUtils={rgbArrayToString:function(t){for(var i=[],n=0;t.length>n;++n){var e=Math.round(t[n]).toString(16);1===e.length&&(e="0"+e),i.push(e)}return"#"+i.join("")},rgbToHsl:function(t,i,n){t/=255,i/=255,n/=255;var e,o,s=Math.max(t,i,n),r=Math.min(t,i,n),a=(s+r)/2;if(s==r)e=o=0;else{var l=s-r;switch(o=a>.5?l/(2-s-r):l/(s+r),s){case t:e=(i-n)/l+(n>i?6:0);break;case i:e=(n-t)/l+2;break;case n:e=(t-i)/l+4}e/=6}return[e,o,a]},hslToRgb:function(t,i,n){function e(t,i,n){return 0>n&&(n+=1),n>1&&(n-=1),1/6>n?t+6*(i-t)*n:.5>n?i:2/3>n?t+6*(i-t)*(2/3-n):t}var o,s,r;if(0==i)o=s=r=n;else{var a=.5>n?n*(1+i):n+i-n*i,l=2*n-a;o=e(l,a,t+1/3),s=e(l,a,t),r=e(l,a,t-1/3)}return[255*o,255*s,255*r]},rgbToHsv:function(t,i,n){t/=255,i/=255,n/=255;var e,o,s=Math.max(t,i,n),r=Math.min(t,i,n),a=s,l=s-r;if(o=0==s?0:l/s,s==r)e=0;else{switch(s){case t:e=(i-n)/l+(n>i?6:0);break;case i:e=(n-t)/l+2;break;case n:e=(t-i)/l+4}e/=6}return[e,o,a]},hsvToRgb:function(t,i,n){var e,o,s,r=Math.floor(6*t),a=6*t-r,l=n*(1-i),u=n*(1-a*i),h=n*(1-(1-a)*i);switch(r%6){case 0:e=n,o=h,s=l;break;case 1:e=u,o=n,s=l;break;case 2:e=l,o=n,s=h;break;case 3:e=l,o=u,s=n;break;case 4:e=h,o=l,s=n;break;case 5:e=n,o=l,s=u}return[255*e,255*o,255*s]}},L.ColorUtils.hslToRgbString=function(t,i,n){return L.ColorUtils.rgbArrayToString(L.ColorUtils.hslToRgb(t,i,n))},L.ColorUtils.hslStringToRgbString=function(t){var i=t.replace("hsl(","").replace(")","").split(","),n=Number(i[0])/360,e=Number(i[1].replace("%",""))/100,o=Number(i[2].replace("%",""))/100;return L.ColorUtils.hslToRgbString(n,e,o)};var PathFunctions=PathFunctions||{__updateStyle:L.Path.prototype._updateStyle,_createDefs:function(){this._defs=this._createElement("defs"),this._container.appendChild(this._defs)},_createGradient:function(t){this._defs||this._createDefs(),this._gradient&&this._defs.removeChild(this._gradient);var i=this._createElement("linearGradient"),n=L.Util.guid();t=t!==!0?$.extend(!0,{},t):{};var e=t.vector||[["0%","0%"],["100%","100%"]],o={x1:e[0][0],x2:e[1][0],y1:e[0][1],y2:e[1][1]};o.id="grad"+n;var s=t.stops||[{offset:"0%",style:{color:"rgb(255, 255, 255)",opacity:1}},{offset:"60%",style:{color:this.options.fillColor||this.options.color,opacity:1}}];for(var r in o)i.setAttribute(r,o[r]);for(var a=0;s.length>a;++a){var l=s[a],u=this._createElement("stop");l.style=l.style||{};for(var r in l){var h=l[r];if("style"===r){var p="";h.color=h.color||this.options.fillColor||this.options.color,h.opacity=h.opacity===void 0?1:h.opacity;for(var c in h)p+="stop-"+c+":"+h[c]+";";h=p}u.setAttribute(r,h)}i.appendChild(u)}this._gradient=i,this._defs.appendChild(i)},_createDropShadow:function(t){this._defs||this._createDefs(),this._dropShadow&&this._defs.removeChild(this._dropShadow);var i=L.Util.guid(),n=this._createElement("filter"),e=this._createElement("feOffset"),o=this._createElement("feGaussianBlur"),s=this._createElement("feBlend");t=t||{width:"200%",height:"200%"},t.id="filter"+i;for(var r in t)n.setAttribute(r,t[r]);var a={result:"offOut","in":"SourceAlpha",dx:"2",dy:"2"},l={result:"blurOut","in":"offOut",stdDeviation:"2"},u={"in":"SourceGraphic",in2:"blurOut",mode:"lighten"};for(var r in a)e.setAttribute(r,a[r]);for(var r in l)o.setAttribute(r,l[r]);for(var r in u)s.setAttribute(r,u[r]);n.appendChild(e),n.appendChild(o),n.appendChild(s),this._dropShadow=n,this._defs.appendChild(n)},_updateStyle:function(){this.__updateStyle.call(this),this.options.stroke&&(this.options.lineCap&&this._path.setAttribute("stroke-linecap",this.options.lineCap),this.options.lineJoin&&this._path.setAttribute("stroke-linejoin",this.options.lineJoin)),this.options.gradient?(this._createGradient(this.options.gradient),this._path.setAttribute("fill","url(#"+this._gradient.getAttribute("id")+")")):this.options.fill||this._path.setAttribute("fill","none"),this.options.dropShadow?(this._createDropShadow(),this._path.setAttribute("filter","url(#"+this._dropShadow.getAttribute("id")+")")):this._path.removeAttribute("filter")}};L.Path.include(PathFunctions),L.Polygon.include(PathFunctions),L.Polyline.include(PathFunctions),L.CircleMarker.include(PathFunctions),L.MapMarker=L.Path.extend({initialize:function(t,i){L.Path.prototype.initialize.call(this,i),this._latlng=t},options:{fill:!0,fillOpacity:1,opacity:1,radius:15,innerRadius:5,position:{x:0,y:0},rotation:0,numberOfSides:50,color:"#000000",fillColor:"#0000FF",weight:1,gradient:!0,dropShadow:!0},setLatLng:function(t){return this._latlng=t,this.redraw()},projectLatlngs:function(){this._point=this._map.latLngToLayerPoint(this._latlng),this._points=this._getPoints(),this.options.innerRadius&&(this._innerPoints=this._getPoints(!0).reverse())},getBounds:function(){var t=this._map,i=3*this.options.radius,n=t.project(this._latlng),e=new L.Point(n.x-this.options.radius,n.y),o=new L.Point(n.x+this.options.radius,n.y-i),s=t.unproject(e),r=t.unproject(o);return new L.LatLngBounds(s,r)},getLatLng:function(){return this._latlng},getPathString:function(){return this._path.setAttribute("shape-rendering","geometricPrecision"),new L.SVGPathBuilder(this._points,this._innerPoints).build(6)},_getPoints:function(t){var i,n,e=t?360:210,o=t?e/Math.max(this.options.numberOfSides,3):e/50,s=t?e+this.options.rotation:e,r=t?this.options.rotation:-30,a=[],l=this.options.radius,u=Math.sqrt(.75),h=function(t){return t*L.LatLng.DEG_TO_RAD},p=this._point;for(t||(a.push(p),a.push(new L.Point(p.x+u*l,p.y-1.5*l)));s>r;)n=h(r),i=this._getPoint(n,l,t),a.push(i),r+=o;return t||a.push(new L.Point(p.x-u*l,p.y-1.5*l)),a},_getPoint:function(t,i,n){var e=i;return i=n?this.options.innerRadius:i,new L.Point(this._point.x+this.options.position.x+i*Math.cos(t),this._point.y-2*e+this.options.position.y-i*Math.sin(t))}}),L.mapMarker=function(t,i){return new L.MapMarker(t,i)},L.RegularPolygonMarker=L.Path.extend({initialize:function(t,i){L.Path.prototype.initialize.call(this,i),this._latlng=t,this.options.numberOfSides=Math.max(this.options.numberOfSides,3)},options:{fill:!0,radiusX:10,radiusY:10,rotation:0,numberOfSides:3,position:{x:0,y:0},maxDegrees:360,gradient:!0,dropShadow:!1},setLatLng:function(t){return this._latlng=t,this.redraw()},projectLatlngs:function(){this._point=this._map.latLngToLayerPoint(this._latlng),this._textPoint=this._point,this._points=this._getPoints(),(this.options.innerRadius||this.options.innerRadiusX&&this.options.innerRadiusY)&&(this._innerPoints=this._getPoints(!0).reverse())},getBounds:function(){var t=this._map,i=this.options.radius||this.options.radiusX,n=this.options.radius||this.options.radiusY,e=i*Math.cos(Math.PI/4),o=n*Math.sin(Math.PI/4),s=t.project(this._latlng),r=new L.Point(s.x-e,s.y+o),a=new L.Point(s.x+e,s.y-o),l=t.unproject(r),u=t.unproject(a);return new L.LatLngBounds(l,u)},getLatLng:function(){return this._latlng},getPathString:function(){return this._path.setAttribute("shape-rendering","geometricPrecision"),new L.SVGPathBuilder(this._points,this._innerPoints).build(6)},_getPoints:function(t){for(var i,n,e=this.options.maxDegrees||360,o=e/Math.max(this.options.numberOfSides,3),s=e+this.options.rotation,r=this.options.rotation,a=[],l=t?this.options.innerRadius||this.options.innerRadiusX:this.options.radius||this.options.radiusX,u=t?this.options.innerRadius||this.options.innerRadiusY:this.options.radius||this.options.radiusY,h=function(t){return t*L.LatLng.DEG_TO_RAD};s>r;)n=h(r),i=this._getPoint(n,l,u),a.push(i),r+=o;return a},_getPoint:function(t,i,n){return new L.Point(this._point.x+this.options.position.x+i*Math.cos(t),this._point.y+this.options.position.y+n*Math.sin(t))}}),L.regularPolygonMarker=function(t,i){return new L.RegularPolygonMarker(t,i)},L.StarMarker=L.RegularPolygonMarker.extend({options:{numberOfPoints:5,rotation:-15,maxDegrees:360,gradient:!0,dropShadow:!0},_getPoints:function(t){for(var i,n,e,o=this.options.maxDegrees||360,s=o/this.options.numberOfPoints,r=o+this.options.rotation,a=this.options.rotation,l=[],u=t?this.options.innerRadius||this.options.innerRadiusX:this.options.radius||this.options.radiusX,h=t?this.options.innerRadius||this.options.innerRadiusY:this.options.radius||this.options.radiusY,p=function(t){return t*L.LatLng.DEG_TO_RAD};r>a;)e=p(a),i=this._getPoint(e,u,h),n=this._getPoint(e+p(s)/2,u/2,h/2),l.push(i),l.push(n),a+=s;return l}}),L.starMarker=function(t,i){return new L.StarMarker(t,i)},L.TriangleMarker=L.RegularPolygonMarker.extend({options:{numberOfSides:3,rotation:30,radius:5}}),L.triangleMarker=function(t,i){return new L.TriangleMarker(t,i)},L.DiamondMarker=L.RegularPolygonMarker.extend({options:{numberOfSides:4,radiusX:5,radiusY:10}}),L.diamondMarker=function(t,i){return new L.DiamondMarker(t,i)},L.SquareMarker=L.RegularPolygonMarker.extend({options:{numberOfSides:4,rotation:45,radius:5}}),L.squareMarker=function(t,i){return new L.SquareMarker(t,i)},L.PentagonMarker=L.RegularPolygonMarker.extend({options:{numberOfSides:5,rotation:-18,radius:5}}),L.pentagonMarker=function(t,i){return new L.PentagonMarker(t,i)},L.HexagonMarker=L.RegularPolygonMarker.extend({options:{numberOfSides:6,rotation:30,radius:5}}),L.hexagonMarker=function(t,i){return new L.HexagonMarker(t,i)},L.OctagonMarker=L.RegularPolygonMarker.extend({options:{numberOfSides:8,rotation:22.5,radius:5}}),L.octagonMarker=function(t,i){return new L.OctagonMarker(t,i)},L.BarMarker=L.Path.extend({initialize:function(t,i){L.Path.prototype.initialize.call(this,i),this._latlng=t},options:{fill:!0,width:2,maxHeight:10,position:{x:0,y:0},weight:1,color:"#000",opacity:1,gradient:!0,dropShadow:!1,lineCap:"square",lineJoin:"miter"},setLatLng:function(t){return this._latlng=t,this.redraw()},projectLatlngs:function(){this._point=this._map.latLngToLayerPoint(this._latlng),this._points=this._getPoints()},getBounds:function(){var t=this._map,i=t.project(this._latlng),n=this.options.width/2,e=new L.Point(i.x-n,i.y),o=new L.Point(i.x+n,i.y-this.options.maxHeight),s=t.unproject(e),r=t.unproject(o);return new L.LatLngBounds(s,r)},getLatLng:function(){return this._latlng},getPathString:function(){return this._path.setAttribute("shape-rendering","crispEdges"),new L.SVGPathBuilder(this._points).build()},_getPoints:function(){var t,i,n,e,o=[],s=this._point.x+this.options.position.x,r=this._point.y+this.options.position.y,a=this.options.width/2,l=this.options.value/this.options.maxValue*this.options.maxHeight;return t=new L.Point(s+a,r),i=new L.Point(s+a,r-l),n=new L.Point(s-a,r-l),e=new L.Point(s-a,r),o=[t,i,n,e]}}),L.barMarker=function(t,i){return new L.BarMarker(t,i)},L.ChartMarker=L.FeatureGroup.extend({initialize:function(t,i){L.Util.setOptions(this,i),this._layers={},this._latlng=t,this._loadComponents()},setLatLng:function(t){return this._latlng=t,this.redraw()},getLatLng:function(){return this._latlng},_loadComponents:function(){},_highlight:function(t){return t.weight&&(t.weight*=2),t},_unhighlight:function(t){return t.weight&&(t.weight/=2),t},_bindMouseEvents:function(t){var i=this,n=this.options.tooltipOptions;t.on("mouseover",function(t){var e,o=this.options,s=o.key,r=o.value,a=t.layerPoint,l=a.x-this._point.x,u=a.y-this._point.y,h=o.iconSize,p=l,c=u,d=5;p=0>l?h.x-l+d:-l-d,c=0>u?h.y-u+d:-u-d,e=new L.Point(p,c);var f={},g=o.displayText?o.displayText(r):r;f[s]={name:o.displayName,value:g};var _=new L.LegendIcon(f,o,{className:"leaflet-div-icon",iconSize:n?n.iconSize:h,iconAnchor:e});o.marker=new L.Marker(i._latlng,{icon:_}),o=i._highlight(o),this.initialize(i._latlng,o),this.redraw(),this.setStyle(o),i.addLayer(o.marker)}),t.on("mouseout",function(){var t=this.options;t=i._unhighlight(t),this.initialize(i._latlng,t),this.redraw(),this.setStyle(t),i.removeLayer(t.marker)})},bindPopup:function(t,i){this.eachLayer(function(n){n.bindPopup(t,i)})},openPopup:function(t){for(var i in this._layers){var n=this._layers[i];t=t||this._latlng,n.openPopup(t);break}},closePopup:function(){for(var t in this._layers){var i=this._layers[t];latlng=latlng||this._latlng,i.closePopup();break}}}),L.BarChartMarker=L.ChartMarker.extend({initialize:function(t,i){L.Util.setOptions(this,i),L.ChartMarker.prototype.initialize.call(this,t,i)},options:{weight:1,opacity:1,color:"#000",fill:!0,position:{x:0,y:0},width:10,offset:0,iconSize:new L.Point(50,40)},_loadComponents:function(){var t,i,n;this.options.rotation,this.options.maxDegrees||360;var e,o=this.options;this.options.radiusX||this.options.radius,this.options.radiusY||this.options.radius;var s,r,a,l=Object.keys(this.options.data),u=l.length,h=this.options.width,p=this.options.offset||0,c=this.options.data,d=this.options.chartOptions;s=-(h*u+p*(u-1))/2+h/2,r=0;for(var f in c)t=c[f],a=d[f],i=a.minValue||0,n=a.maxValue||100,o.fillColor=a.fillColor||this.options.fillColor,o.value=t,o.minValue=i,o.maxValue=n,o.position={x:s,y:r},o.width=h,o.maxHeight=a.maxHeight||10,o.key=f,o.value=t,o.displayName=a.displayName,o.opacity=this.options.opacity||1,o.fillOpacity=this.options.fillOpacity||.7,o.weight=this.options.weight||1,o.color=a.color||this.options.color,o.displayText=a.displayText,e=new L.BarMarker(this._latlng,o),this._bindMouseEvents(e),this.addLayer(e),s+=h+p}}),L.RadialBarMarker=L.Path.extend({initialize:function(t,i){L.Path.prototype.initialize.call(this,i),this._latlng=t},options:{fill:!0,radius:10,rotation:0,numberOfSides:30,position:{x:0,y:0},gradient:!0,dropShadow:!1},setLatLng:function(t){return this._latlng=t,this.redraw()},projectLatlngs:function(){this._point=this._map.latLngToLayerPoint(this._latlng),this._points=this._getPoints()},getBounds:function(){var t=this._map,i=this.options.radiusX||this.options.radius,n=this.options.radiusY||this.options.radius,e=i*Math.cos(Math.PI/4),o=n*Math.sin(Math.PI/4),s=t.project(this._latlng),r=new L.Point(s.x-e,s.y+o),a=new L.Point(s.x+e,s.y-o),l=t.unproject(r),u=t.unproject(a);return new L.LatLngBounds(l,u)},getLatLng:function(){return this._latlng},getPathString:function(){var t=this.options.endAngle-this.options.startAngle,i=t>=180?"1":"0",n=this.options.radiusX||this.options.radius,e=this.options.radiusY||this.options.radius,o="M"+this._points[0].x.toFixed(2)+","+this._points[0].y.toFixed(2)+"A"+n.toFixed(2)+","+e.toFixed(2)+" 0 "+i+",1 "+this._points[1].x.toFixed(2)+","+this._points[1].y.toFixed(2)+"L";return this._innerPoints?(o=o+this._innerPoints[0].x.toFixed(2)+","+this._innerPoints[0].y.toFixed(2),o=o+"A"+(n-this.options.barThickness).toFixed(2)+","+(e-this.options.barThickness).toFixed(2)+" 0 "+i+",0 "+this._innerPoints[1].x.toFixed(2)+","+this._innerPoints[1].y.toFixed(2)+"z"):o=o+this._point.x.toFixed(2)+","+this._point.y.toFixed(2)+"z",L.Browser.vml&&(o=Core.SVG.path(o)),this._path.setAttribute("shape-rendering","geometricPrecision"),o},_getPoints:function(){var t=this.options.endAngle-this.options.startAngle;t/this.options.numberOfSides;var i=this.options.endAngle+this.options.rotation,n=this.options.startAngle+this.options.rotation,e=[],o="radiusX"in this.options?this.options.radiusX:this.options.radius,s="radiusY"in this.options?this.options.radiusY:this.options.radius,r=function(t){return t*L.LatLng.DEG_TO_RAD};360===t&&(i-=.1);var a=r(n),l=r(i);return e.push(this._getPoint(a,o,s)),e.push(this._getPoint(l,o,s)),this.options.barThickness&&(this._innerPoints=[],o-this.options.barThickness,s-this.options.barThickness,this._innerPoints.push(this._getPoint(l,o-this.options.barThickness,s-this.options.barThickness)),this._innerPoints.push(this._getPoint(a,o-this.options.barThickness,s-this.options.barThickness))),e},_getPoint:function(t,i,n){return new L.Point(this._point.x+this.options.position.x+i*Math.cos(t),this._point.y+this.options.position.y+n*Math.sin(t))}}),L.radialBarMarker=function(t,i){return new L.RadialBarMarker(t,i)},L.PieChartMarker=L.ChartMarker.extend({initialize:function(t,i){L.Util.setOptions(this,i),L.ChartMarker.prototype.initialize.call(this,t,i)},options:{weight:1,opacity:1,color:"#000",fill:!0,radius:10,rotation:0,numberOfSides:50,mouseOverExaggeration:1.2,maxDegrees:360,iconSize:new L.Point(50,40)},_highlight:function(t){var i=t.radiusX,n=t.radiusY,e=t.barThickness;return t.oldBarThickness=e,t.oldRadiusX=i,t.oldRadiusY=n,t.radiusX*=t.mouseOverExaggeration,t.radiusY*=t.mouseOverExaggeration,t.barThickness=t.radiusX-i+e,t},_unhighlight:function(t){return t.radiusX=t.oldRadiusX,t.radiusY=t.oldRadiusY,t.barThickness=t.oldBarThickness,t},_loadComponents:function(){var t,i,n,e,o=0,s=0,r=0,a=this.options.maxDegrees||360,l=this.options.rotation,u=this.options,h=this.options.data,p=this.options.chartOptions,c=function(t,i){var n=0;return t[i]&&(n=parseFloat(t[i])),n};for(e in h)t=c(h,e),o+=t;if(o>0)for(e in h)t=parseFloat(h[e]),n=p[e],r=t/o,s=r*a,u.startAngle=l,u.endAngle=l+s,u.fillColor=n.fillColor,u.color=n.color||"#000",u.radiusX=this.options.radiusX||this.options.radius,u.radiusY=this.options.radiusY||this.options.radius,u.rotation=0,u.key=e,u.value=t,u.displayName=n.displayName,u.displayText=n.displayText,i=new L.RadialBarMarker(this._latlng,u),this._bindMouseEvents(i),l=u.endAngle,this.addLayer(i)}}),L.pieChartMarker=function(t,i){return new L.PieChartMarker(t,i)},L.CoxcombChartMarker=L.PieChartMarker.extend({statics:{SIZE_MODE_RADIUS:"radius",SIZE_MODE_AREA:"area"}}),L.CoxcombChartMarker=L.CoxcombChartMarker.extend({initialize:function(t,i){L.Util.setOptions(this,i),L.PieChartMarker.prototype.initialize.call(this,t,i)},options:{weight:1,opacity:1,color:"#000",fill:!0,radius:10,rotation:0,numberOfSides:50,mouseOverExaggeration:1.2,maxDegrees:360,iconSize:new L.Point(50,40),sizeMode:L.CoxcombChartMarker.SIZE_MODE_AREA},_loadComponents:function(){var t,i,n,e,o,s=0,r=this.options.maxDegrees||360,a=this.options.rotation,l=this.options,u="radiusX"in this.options?this.options.radiusX:this.options.radius,h="radiusY"in this.options?this.options.radiusY:this.options.radius,p=Object.keys(this.options.data),c=p.length,d=this.options.data,f=this.options.chartOptions;
s=r/c;for(var g in d){t=parseFloat(d[g]),o=f[g];var i=o.minValue||0,n=o.maxValue;if(this.options.sizeMode===L.CoxcombChartMarker.SIZE_MODE_RADIUS){var _=new L.LinearFunction(new L.Point(i,0),new L.Point(n,u)),y=new L.LinearFunction(new L.Point(i,0),new L.Point(n,h));l.radiusX=_.evaluate(t),l.radiusY=y.evaluate(t)}else{var v=Math.max(u,h),P=Math.PI*Math.pow(v,2)/c,m=new L.LinearFunction(new L.Point(i,0),new L.Point(n,P),{postProcess:function(t){return Math.sqrt(c*t/Math.PI)}});l.radiusX=m.evaluate(t),l.radiusY=l.radiusX}l.startAngle=a,l.endAngle=a+s,l.fillColor=o.fillColor,l.color=o.color||"#000",l.rotation=0,l.key=g,l.value=t,l.displayName=o.displayName,l.displayText=o.displayText,e=new L.RadialBarMarker(this._latlng,l),this._bindMouseEvents(e),a=l.endAngle,this.addLayer(e)}}}),L.coxcombChartMarker=function(t,i){return new L.CoxcombChartMarker(t,i)},L.RadialBarChartMarker=L.ChartMarker.extend({initialize:function(t,i){L.Util.setOptions(this,i),L.ChartMarker.prototype.initialize.call(this,t,i)},options:{weight:1,opacity:1,color:"#000",fill:!0,radius:10,rotation:0,numberOfSides:30,offset:2,barThickness:5,maxDegrees:360,iconSize:new L.Point(50,40)},_loadComponents:function(){var t,i,n,e,o,s=this.options.rotation,r=this.options.maxDegrees||360,a=this.options,l=this.options.radiusX||this.options.radius,u=this.options.radiusY||this.options.radius,h=this.options.data,p=this.options.chartOptions,c=this.options.barThickness||4,d=this.options.offset||2;for(var f in h){t=parseFloat(h[f]),o=p[f],i=o.minValue||0,n=o.maxValue||100;var g=new L.LinearFunction(new L.Point(i,0),new L.Point(n,r));s=g.evaluate(t),a.startAngle=this.options.rotation,a.endAngle=this.options.rotation+s,a.fillColor=o.fillColor,a.radiusX=l,a.radiusY=u,a.barThickness=c,a.rotation=0,a.key=f,a.value=t,a.displayName=o.displayName,a.displayText=o.displayText,a.weight=this.options.weight||1,e=new L.RadialBarMarker(this._latlng,a),this._bindMouseEvents(e),this.addLayer(e),l+=c+d,u+=c+d}}}),L.radialBarChartMarker=function(t,i){return new L.RadialBarChartMarker(t,i)},L.StackedRegularPolygonMarker=L.ChartMarker.extend({options:{iconSize:new L.Point(50,40)},initialize:function(t,i){L.Util.setOptions(this,i),L.ChartMarker.prototype.initialize.call(this,t,i)},_loadComponents:function(){var t,i,n,e,o=0,s=0,r=this.options,a=this.options.data,l=this.options.chartOptions;for(e in a){t=parseFloat(a[e]),n=l[e],minValue=n.minValue||0,maxValue=n.maxValue||100,minRadius=n.minRadius||0,maxRadius=n.maxRadius||10,r.fillColor=n.fillColor||this.options.fillColor,r.value=t,r.minValue=minValue,r.maxValue=maxValue;var u=new L.LinearFunction(new L.Point(minValue,minRadius),new L.Point(maxValue,maxRadius)),h=u.evaluate(t);r.radiusX=o+h,r.radiusY=s+h,r.innerRadiusX=o,r.innerRadiusY=s,r.key=e,r.displayName=n.displayName,r.opacity=this.options.opacity||1,r.fillOpacity=this.options.fillOpacity||.7,r.weight=this.options.weight||1,r.color=n.color||this.options.color,r.displayText=n.displayText,i=new L.RegularPolygonMarker(this._latlng,r),this._bindMouseEvents(i),o=r.radiusX,s=r.radiusY,this.addLayer(i)}}}),L.RadialMeterMarker=L.ChartMarker.extend({initialize:function(t,i){L.Util.setOptions(this,i),L.ChartMarker.prototype.initialize.call(this,t,i)},options:{weight:1,opacity:1,color:"#000",fill:!0,radius:10,rotation:180,numberOfSides:30,offset:2,barThickness:5,maxDegrees:180,iconSize:new L.Point(50,40),backgroundStyle:{fill:!0,fillColor:"#707070",fillOpacity:.2,opacity:.8,color:"#505050"}},_loadComponents:function(){var t,i,n,e,o,s,r=this.options.rotation,a=this.options.maxDegrees||360,l=this.options,u=this.options.radiusX||this.options.radius,h=this.options.radiusY||this.options.radius,p=this.options.data,c=this.options.chartOptions,d=this.options.barThickness||4,f=r,g=this.options.numSegments||10,_=a/g;for(var y in p){t=parseFloat(p[y]),o=c[y],s=this.options.displayOptions?this.options.displayOptions[y]:{},i=o.minValue||0,n=o.maxValue||100;for(var v=n-i,P=a/v*(t-i),m=r+P,x=r+a,b=new L.LinearFunction(new L.Point(r,i),new L.Point(x,n));m>f;){l.startAngle=f;var w=Math.min(_,m-f);l.endAngle=f+w,l.fillColor=o.fillColor,l.radiusX=u,l.radiusY=h,l.barThickness=d,l.rotation=0,l.key=y,l.value=t,l.displayName=o.displayName,l.displayText=o.displayText;var M=b.evaluate(f+w);for(var k in s)l[k]=s[k].evaluate?s[k].evaluate(M):s[k];e=new L.RadialBarMarker(this._latlng,l),this._bindMouseEvents(e),this.addLayer(e),f+=w}if(this.options.backgroundStyle&&x>f){var w=x-f;l.endAngle=f+w,l.radiusX=u,l.radiusY=h,l.barThickness=d,l.rotation=0,l.key=y,l.value=t,l.displayName=o.displayName,l.displayText=o.displayText,l.fillColor=null,l.fill=!1,l.gradient=!1;for(var C in this.options.backgroundStyle)l[C]=this.options.backgroundStyle[C];var M=b.evaluate(f+w);e=new L.RadialBarMarker(this._latlng,l),this.addLayer(e)}}}});