/*
 @preserve Leaflet Data Visualization Framework, a JavaScript library for creating thematic maps using Leaflet
 (c) 2013, Scott Fairgrieve, HumanGeo
*/
L.LinearFunction=L.Class.extend({initialize:function(t,i,n){this.setOptions(n),this.setRange(t,i)},_calculateParameters:function(t,i){0===this._xRange?(this._slope=0,this._b=t.y):(this._slope=(i.y-t.y)/this._xRange,this._b=t.y-this._slope*t.x)},_arrayToPoint:function(t){return{x:t[0],y:t[1]}},setOptions:function(t){L.Util.setOptions(this,t),this._preProcess=this.options.preProcess,this._postProcess=this.options.postProcess},getBounds:function(){var t=Math.min(this._minPoint.x,this._maxPoint.x),i=Math.max(this._minPoint.x,this._maxPoint.x),n=Math.min(this._minPoint.y,this._maxPoint.y),e=Math.max(this._minPoint.y,this._maxPoint.y);return[new L.Point(t,n),new L.Point(i,e)]},setRange:function(t,i){return t=t instanceof Array?this._arrayToPoint(t):t,i=i instanceof Array?this._arrayToPoint(i):i,this._minPoint=t,this._maxPoint=i,this._xRange=i.x-t.x,this._calculateParameters(t,i),this},setMin:function(t){return this.setRange(t,this._maxPoint),this},setMax:function(t){return this.setRange(this._minPoint,t),this},setPreProcess:function(t){return this._preProcess=t,this},setPostProcess:function(t){return this._postProcess=t,this},evaluate:function(t){var i;return this._preProcess&&(t=this._preProcess(t)),i=Number((this._slope*t).toFixed(6))+Number(this._b.toFixed(6)),this._postProcess&&(i=this._postProcess(i)),i},random:function(){var t=Math.random()*this._xRange+this._minPoint.x;return this.evaluate(t)},sample:function(t){t=Math.max(t,2);for(var i=t-1,n=this._xRange/i,e=this._minPoint.x,o=[];this._maxPoint.x>=e;)o.push(this.evaluate(e)),e+=n;return o},samplePoints:function(t){t=Math.max(t,2);for(var i=t-1,n=this._xRange/i,e=this._minPoint.x,o=[];this._maxPoint.x>=e;)o.push(new L.Point(e,this.evaluate(e))),e+=n;return o}}),L.ColorFunction=L.LinearFunction.extend({options:{alpha:1,includeAlpha:!1},initialize:function(t,i,n){L.Util.setOptions(this,n),this._parts=[],this._dynamicPart=null,this._outputPrecision=0,this._prefix=null,this._formatOutput=function(t){return t.toFixed(this._outputPrecision)},this._mapOutput=function(t){for(var i=[],n=0;this._parts.length>n;++n){var e=this._parts[n];i.push(t[e])}return this.options.includeAlpha&&i.push(this.options.alpha),i},this._getColorString=function(t){t=this._formatOutput(t),this.options[this._dynamicPart]=t;var i=this._mapOutput(this.options);return this._writeColor(this._prefix,i)},this._writeColor=function(t,i){return this.options.includeAlpha&&(t+="a"),t+"("+i.join(",")+")"};var e=function(t){n&&n.postProcess&&(t=n.postProcess.call(this,t));var i=this._getColorString(t);return(L.Browser.ie6||L.Browser.ie7)&&i.indexOf("hsl")>-1&&(i=L.ColorUtils.hslStringToRgbString(i)),i};L.LinearFunction.prototype.initialize.call(this,t,i,{preProcess:this.options.preProcess,postProcess:e})}}),L.HSLColorFunction=L.ColorFunction.extend({initialize:function(t,i,n){L.ColorFunction.prototype.initialize.call(this,t,i,n),this._parts=["outputHue","outputSaturation","outputLuminosity"],this._prefix="hsl",this._outputPrecision=2}}),L.RGBColorFunction=L.ColorFunction.extend({initialize:function(t,i,n){L.ColorFunction.prototype.initialize.call(this,t,i,n),this._parts=["outputRed","outputBlue","outputGreen"],this._prefix="rgb",this._outputPrecision=0}}),L.RGBRedFunction=L.LinearFunction.extend({options:{outputGreen:0,outputBlue:0},initialize:function(t,i,n){L.RGBColorFunction.prototype.initialize.call(this,t,i,n),this._dynamicPart="outputRed"}}),L.RGBBlueFunction=L.LinearFunction.extend({options:{outputRed:0,outputGreen:0},initialize:function(t,i,n){L.RGBColorFunction.prototype.initialize.call(this,t,i,n),this._dynamicPart="outputBlue"}}),L.RGBGreenFunction=L.LinearFunction.extend({options:{outputRed:0,outputBlue:0},initialize:function(t,i,n){L.RGBColorFunction.prototype.initialize.call(this,t,i,n),this._dynamicPart="outputGreen"}}),L.RGBColorBlendFunction=L.LinearFunction.extend({initialize:function(t,i,n,e){var o=n[0],a=e[0],s=n[1],r=e[1],l=n[2],h=e[2],u=function(t){return t.toFixed(0)};this._minX=t,this._maxX=i,this._redFunction=new L.LinearFunction(new L.Point(t,o),new L.Point(i,a),{postProcess:u}),this._greenFunction=new L.LinearFunction(new L.Point(t,s),new L.Point(i,r),{postProcess:u}),this._blueFunction=new L.LinearFunction(new L.Point(t,l),new L.Point(i,h),{postProcess:u})},getBounds:function(){var t=this._redFunction.getBounds(),i=this._greenFunction.getBounds(),n=this._blueFunction.getBounds(),e=Math.min(t[0].y,i[0].y,n[0].y),o=Math.max(t[0].y,i[0].y,n[0].y);return[new L.Point(t[0].x,e),new L.Point(t[1].x,o)]},evaluate:function(t){return"rgb("+[this._redFunction.evaluate(t),this._greenFunction.evaluate(t),this._blueFunction.evaluate(t)].join(",")+")"}}),L.HSLHueFunction=L.HSLColorFunction.extend({options:{outputSaturation:"100%",outputLuminosity:"50%"},initialize:function(t,i,n){L.HSLColorFunction.prototype.initialize.call(this,t,i,n),this._dynamicPart="outputHue"}}),L.HSLSaturationFunction=L.LinearFunction.extend({options:{outputHue:0,outputLuminosity:"50%"},initialize:function(t,i,n){L.HSLColorFunction.prototype.initialize.call(this,t,i,n),this._formatOutput=function(t){return(100*t).toFixed(this._outputPrecision)+"%"},this._dynamicPart="outputSaturation"}}),L.HSLLuminosityFunction=L.LinearFunction.extend({options:{outputHue:0,outputSaturation:"100%"},initialize:function(t,i,n){L.HSLColorFunction.prototype.initialize.call(this,t,i,n),this._formatOutput=function(t){return(100*t).toFixed(this._outputPrecision)+"%"},this._dynamicPart="outputLuminosity"}}),L.PiecewiseFunction=L.LinearFunction.extend({initialize:function(t,i){L.Util.setOptions(this,i),this._functions=t;var n,e;n=t[0].getBounds()[0],e=t[t.length-1].getBounds()[1],L.LinearFunction.prototype.initialize.call(this,n,e,{preProcess:this.options.preProcess,postProcess:this.options.postProcess})},_getFunction:function(t){for(var i,n,e,o,a=!1,s=0;this._functions.length>s;++s)if(o=this._functions[s],i=o.getBounds(),n=i[0],e=i[1],t>=n.x&&e.x>t){a=!0;break}return a?o:this._functions[this._functions.length-1]},evaluate:function(t){var i,n=null;return this._preProcess&&(t=this._preProcess(t)),i=this._getFunction(t),i&&(n=i.evaluate(t),this._postProcess&&(n=this._postProcess(n))),n}}),L.CategoryFunction=L.Class.extend({initialize:function(t,i){L.Util.setOptions(this,i),this._categoryKeys=Object.keys(t),this._categoryMap=t,this._preProcess=this.options.preProcess,this._postProcess=this.options.postProcess},evaluate:function(t){var i;return this._preProcess&&(t=this._preProcess(t)),i=this._categoryMap[t],this._postProcess&&(i=this._postProcess(i)),i},getCategories:function(){return this._categoryKeys}}),Object.keys||(Object.keys=function(){var t=Object.prototype.hasOwnProperty,i=!{toString:null}.propertyIsEnumerable("toString"),n=["toString","toLocaleString","valueOf","hasOwnProperty","isPrototypeOf","propertyIsEnumerable","constructor"],e=n.length;return function(o){var a,s,r;if("object"!=typeof o&&"function"!=typeof o||null===o)throw new TypeError("Object.keys called on non-object");a=[];for(s in o)t.call(o,s)&&a.push(s);if(i)for(r=0;e>r;r++)t.call(o,n[r])&&a.push(n[r]);return a}}()),L.Util.guid=function(){var t=function(){return Math.floor(65536*(1+Math.random())).toString(16).substring(1)};return t()+t()+"-"+t()+"-"+t()+"-"+t()+"-"+t()+t()+t()},L.Util.getProperty=function(t,i,n){return i in t?t[i]:n},L.Util.setFieldValue=function(t,i,n){for(var e,o=i.split("."),a=t,s=0;o.length-1>s;++s)e=o[s],a[e]=a[e]||{},a=a[e];a[o[o.length-1]]=n},L.Util.getFieldValue=function(t,i){var n=null;if(i){for(var e,o,a,s,r,l,h,u=i.split("."),p=t,c=-1,d=0;u.length>d;++d)if(e=u[d],c=e.indexOf("["),c>-1){l=e.substring(c),e=e.substring(0,c),l=l.replace("[","").replace("]",""),o=l.split("="),a=o[0],s=o[1],p=p[e];for(var L=0;p.length>L;++L)r=p[L],h=r[a],h&&h===s&&(p=r)}else{if(!p||!p.hasOwnProperty(e)){p=null;break}p=p[e]}n=p}else n=t;return n},L.CategoryLegend=L.Class.extend({initialize:function(t){L.Util.setOptions(this,t)},generate:function(t){t=t||{};var i='<div class="legend"></div>',n=$(i),e=t.className,o=this.options;e&&n.addClass(e),t.title&&n.append('<div class="legend-title">'+t.title+"</div>");for(var a in o){categoryOptions=o[a];var s=categoryOptions.displayName||a,r=$('<div class="data-layer-legend"><div class="legend-box"></div><div class="key">'+s+"</div></div>"),l=r.find(".legend-box");L.StyleConverter.applySVGStyle(l,categoryOptions),n.append(r)}return n.wrap("<div/>").parent().html()}}),L.LegendIcon=L.DivIcon.extend({initialize:function(t,i,n){var e,o='<div class="legend-content"><div class="title"></div><div class="legend-box"></div><div class="legend-values"></div></div>',a=$(o),s=a.find(".legend-box"),r=a.find(".legend-values"),l=i.title||i.name;l&&a.find(".title").text(l);for(var h in t){e=t[h];var u=e.name||h,p=e.value;r.append('<div class="key">'+u+'</div><div class="value">'+p+"</div>")}L.StyleConverter.applySVGStyle(s,i),s.height(5),o=a.wrap("<div>").parent().html(),n.html=o,n.className=n.className||"legend-icon",L.DivIcon.prototype.initialize.call(this,n)}}),L.legendIcon=function(t,i,n){return new L.LegendIcon(t,i,n)},L.GeometryUtils={getName:function(t){var i=null;if(t&&t.features)for(var n=0;t.features.length>n;++n){var e=t.features[n];if(e.properties&&e.properties.name){i=e.properties.name;break}}return i},getGeoJSONLocation:function(t,i,n,e){var o=new L.GeoJSON(t,{pointToLayer:function(t,o){var a={location:o,text:n?L.Util.getFieldValue(i,n):[o.lat.toFixed(3),o.lng.toFixed(3)].join(", "),center:o};return e(a,i)}}),a=null;try{a=L.GeometryUtils.loadCentroid(t)}catch(s){console.log("Error loading centroid for "+JSON.stringify(t))}return{location:o,text:n?L.Util.getFieldValue(i,n):null,center:a}},mergeProperties:function(t,i,n){var e,o,a=i.features,s=L.GeometryUtils.indexFeatureCollection(a,n),r={type:"FeatureCollection",features:[]};for(var l in t)if(t.hasOwnProperty(l)&&(e=t[l],o=e[n])){var h=s[o];for(var u in e)h.properties[u]=e[u];r.features.push(h)}return r},indexFeatureCollection:function(t,i){for(var n,e,o,a=t.features,s={},r=0;a.length>r;++r)n=a[r],e=n.properties,o=e[i],s[o]=n;return s},arrayToMap:function(t,i,n){for(var e,o,a,s={},r=0;t.length>r;++r)e=t[r],o=e[i],a=n?e[n]:e,s[o]=a;return s},arrayToMaps:function(t,i){for(var n,e,o,a,s,r,l,h=[],u=0;i.length>u;++u)h.push({});for(var p=0;t.length>p;++p){e=t[p];for(var c=0;i.length>c;++c)n=h[c],s=i[c],r=s.from,l=s.to,o=e[r],a=l?e[l]:e,n[o]=a}return h},loadCentroid:function(t){var i,n,e,o=null;if(t.geometry&&"Point"===t.geometry.type)o=new L.LatLng(t.geometry.coordinates[1],t.geometry.coordinates[0]);else if("undefined"!=typeof jsts){var a=new jsts.io.GeoJSONParser,s=a.read(t);if(s.getCentroid)i=s.getCentroid(),n=i.coordinate.x,e=i.coordinate.y;else if(s.features){for(var r=0,l=0,h=0;s.features.length>h;++h)i=s.features[h].geometry.getCentroid(),r+=i.coordinate.x,l+=i.coordinate.y;n=r/s.features.length,e=l/s.features.length}else i=s.geometry.getCentroid(),n=i.coordinate.x,e=i.coordinate.y;o=new L.LatLng(e,n)}return o},loadCentroids:function(t){var i,n={};for(var e in t)i=t[e],n[e]=L.GeometryUtils.loadCentroid(i);return n}},L.SVGPathBuilder=L.Class.extend({initialize:function(t,i,n){this._points=t||[],this._innerPoints=i||[],L.Util.setOptions(this,n)},options:{closePath:!0},_getPathString:function(t,i){var n="";if(t.length>0){var e=t[0],i=null!==i?i:2,o="M",a="L",s="Z";L.Browser.vml&&(i=0,o="m",a="|",s="xe"),n=o+e.x.toFixed(i)+","+e.y.toFixed(i);for(var r=1;t.length>r;r++)e=t[r],n+=a+e.x.toFixed(i)+","+e.y.toFixed(i);this.options.closePath&&(n+=s)}return n},addPoint:function(t,i){i?this._innerPoints.push(t):this._points.push(t)},build:function(t){t=t||this.options.digits;var i=this._getPathString(this._points,t);return this._innerPoints&&(i+=this._getPathString(this._innerPoints,t)),i}}),L.StyleConverter={keyMap:{fillColor:{property:["background-color"],valueFunction:function(t){return t}},color:{property:["color","border-top-color","border-right-color","border-bottom-color","border-left-color"],valueFunction:function(t){return t}},weight:{property:["border-width"],valueFunction:function(t){return Math.ceil(t)+"px"}},stroke:{property:["border-style"],valueFunction:function(t){return t===!0?"solid":"none"}},dashArray:{property:["border-style"],valueFunction:function(t){var i="solid";return t&&(i="dashed"),i}},barThickness:{property:["height"],valueFunction:function(t){return t+"px"}},radius:{property:["height"],valueFunction:function(t){return 2*t+"px"}},fillOpacity:{property:["opacity"],valueFunction:function(t){return t}}},applySVGStyle:function(t,i,n){var e=L.StyleConverter.keyMap;n&&(e=L.Util.extend(e,n)),t.css("border-style","solid");for(var o in i)t=L.StyleConverter.setCSSProperty(t,o,i[o],e);return t},setCSSProperty:function(t,i,n,e){var e=e||L.StyleConverter.keyMap,o=e[i];if(o)for(var a=o.property,s=0;a.length>s;++s)t.css(a[s],o.valueFunction(n));return t}},L.StylesBuilder=L.Class.extend({initialize:function(t,i){this._categories=t,this._styleFunctionMap=i,this._buildStyles()},_buildStyles:function(){for(var t,i,n,e={},o=0;this._categories.length>o;++o){t=this._categories[o],e[t]={};for(var a in this._styleFunctionMap)i=this._styleFunctionMap[a],n=i.evaluate?i.evaluate(o):"function"==typeof i?i(o):i,e[t][a]=n}this._styleMap=e},getStyles:function(){return this._styleMap}}),L.PaletteBuilder=L.Class.extend({initialize:function(t){this._styleFunctionMap=t},generate:function(t){t=t||{};var i=$('<div class="palette"></div>'),n=t.count||10,e=function(t){for(var i=[],n=0;t>n;++n)i.push(n);return i}(n),o=new L.StylesBuilder(e,this._styleFunctionMap),a=o.getStyles();t.className&&i.addClass(t.className);for(var s in a){var r=$('<i class="palette-element"></i>'),l=a[s];L.StyleConverter.applySVGStyle(r,l),i.append(r)}return i.wrap("<div/>").parent().html()}}),L.HTMLUtils={buildTable:function(t,i,n){i=i||"table table-condensed table-striped table-bordered";var e='<table class="'+i+'"><thead><tr><th>Name</th><th>Value</th></tr></thead><tbody></tbody></table>',o=$(e),a=o.find("tbody");n=n||[];for(var s in t)t.hasOwnProperty(s)&&-1===$.inArray(n,s)&&($.isPlainObject(t[s])||t[s]instanceof Array?a.append("<tr><td>"+s+"</td><td>"+L.HTMLUtils.buildTable(t[s],n).wrap("<div/>").parent().html()+"</td></tr>"):a.append("<tr><td>"+s+"</td><td>"+t[s]+"</td></tr>"));return o}},L.AnimationUtils={animate:function(t,i,n,e){var o=e.delay||0,a=e.frames||30,s=e.duration||500,r={},l=e.easeFunction||function(t){return t},h=e.complete,u=s/a;for(var p in i)"color"!=p&&"fillColor"!=p&&n[p]&&(r[p]=new L.LinearFunction([0,i[p]],[a-1,n[p]]));var c={},d=0,g=function(){for(var i in r)c[i]=r[i].evaluate(d);t.options=$.extend(!0,{},t.options,c),t.redraw(),d++,u=l(u),a>d?setTimeout(g,u):h()};setTimeout(g,o)}},L.ColorUtils={rgbArrayToString:function(t){for(var i=[],n=0;t.length>n;++n){var e=Math.round(t[n]).toString(16);1===e.length&&(e="0"+e),i.push(e)}return"#"+i.join("")},rgbToHsl:function(t,i,n){t/=255,i/=255,n/=255;var e,o,a=Math.max(t,i,n),s=Math.min(t,i,n),r=(a+s)/2;if(a==s)e=o=0;else{var l=a-s;switch(o=r>.5?l/(2-a-s):l/(a+s),a){case t:e=(i-n)/l+(n>i?6:0);break;case i:e=(n-t)/l+2;break;case n:e=(t-i)/l+4}e/=6}return[e,o,r]},hslToRgb:function(t,i,n){function e(t,i,n){return 0>n&&(n+=1),n>1&&(n-=1),1/6>n?t+6*(i-t)*n:.5>n?i:2/3>n?t+6*(i-t)*(2/3-n):t}var o,a,s;if(0==i)o=a=s=n;else{var r=.5>n?n*(1+i):n+i-n*i,l=2*n-r;o=e(l,r,t+1/3),a=e(l,r,t),s=e(l,r,t-1/3)}return[255*o,255*a,255*s]},rgbToHsv:function(t,i,n){t/=255,i/=255,n/=255;var e,o,a=Math.max(t,i,n),s=Math.min(t,i,n),r=a,l=a-s;if(o=0==a?0:l/a,a==s)e=0;else{switch(a){case t:e=(i-n)/l+(n>i?6:0);break;case i:e=(n-t)/l+2;break;case n:e=(t-i)/l+4}e/=6}return[e,o,r]},hsvToRgb:function(t,i,n){var e,o,a,s=Math.floor(6*t),r=6*t-s,l=n*(1-i),h=n*(1-r*i),u=n*(1-(1-r)*i);switch(s%6){case 0:e=n,o=u,a=l;break;case 1:e=h,o=n,a=l;break;case 2:e=l,o=n,a=u;break;case 3:e=l,o=h,a=n;break;case 4:e=u,o=l,a=n;break;case 5:e=n,o=l,a=h}return[255*e,255*o,255*a]}},L.ColorUtils.hslToRgbString=function(t,i,n){return L.ColorUtils.rgbArrayToString(L.ColorUtils.hslToRgb(t,i,n))},L.ColorUtils.hslStringToRgbString=function(t){var i=t.replace("hsl(","").replace(")","").split(","),n=Number(i[0])/360,e=Number(i[1].replace("%",""))/100,o=Number(i[2].replace("%",""))/100;return L.ColorUtils.hslToRgbString(n,e,o)},L.RegularPolygon=L.Polygon.extend({statics:{R:6378.137,M_PER_KM:1e3},initialize:function(t,i){this._centerLatLng=t,L.Util.setOptions(this,i),L.Polygon.prototype.initialize.call(this,this._getLatLngs(),i)},options:{fill:!0,radius:1e3,numberOfSides:4,rotation:0,maxDegrees:360},getLatLng:function(){return this._centerLatLng},setRadius:function(t){this.options.radius=t,this._latlngs=this._getLatLngs(),this.redraw()},_getLatLngs:function(){for(var t,i=this.options.maxDegrees||360,n=i/Math.max(this.options.numberOfSides,3),e=i+this.options.rotation,o=this.options.rotation,a=[];e>o;)t=this._getPoint(o),a.push(t),o+=n;return a},_getPoint:function(t){var i=function(t){return t*L.LatLng.DEG_TO_RAD},n=function(t){return t*L.LatLng.RAD_TO_DEG},e=i(t),o=this.options.radius/L.RegularPolygon.M_PER_KM/L.RegularPolygon.R,a=i(this._centerLatLng.lat),s=i(this._centerLatLng.lng),r=Math.asin(Math.sin(a)*Math.cos(o)+Math.cos(a)*Math.sin(o)*Math.cos(e)),l=s+Math.atan2(Math.sin(e)*Math.sin(o)*Math.cos(a),Math.cos(o)-Math.sin(a)*Math.sin(r));return r=n(r),l=n(l),new L.LatLng(r,l)}}),L.regularPolygon=function(t,i){return new L.RegularPolygon(t,i)};var PathFunctions=PathFunctions||{__updateStyle:L.Path.prototype._updateStyle,_createDefs:function(){this._defs=this._createElement("defs"),this._container.appendChild(this._defs)},_createGradient:function(t){this._defs||this._createDefs(),this._gradient&&this._defs.removeChild(this._gradient);var i=this._createElement("linearGradient"),n=L.Util.guid();t=t!==!0?$.extend(!0,{},t):{};var e=t.vector||[["0%","0%"],["100%","100%"]],o={x1:e[0][0],x2:e[1][0],y1:e[0][1],y2:e[1][1]};o.id="grad"+n;var a=t.stops||[{offset:"0%",style:{color:"rgb(255, 255, 255)",opacity:1}},{offset:"60%",style:{color:this.options.fillColor||this.options.color,opacity:1}}];for(var s in o)i.setAttribute(s,o[s]);for(var r=0;a.length>r;++r){var l=a[r],h=this._createElement("stop");l.style=l.style||{};for(var s in l){var u=l[s];if("style"===s){var p="";u.color=u.color||this.options.fillColor||this.options.color,u.opacity=u.opacity===void 0?1:u.opacity;for(var c in u)p+="stop-"+c+":"+u[c]+";";u=p}h.setAttribute(s,u)}i.appendChild(h)}this._gradient=i,this._defs.appendChild(i)},_createDropShadow:function(t){this._defs||this._createDefs(),this._dropShadow&&this._defs.removeChild(this._dropShadow);var i=L.Util.guid(),n=this._createElement("filter"),e=this._createElement("feOffset"),o=this._createElement("feGaussianBlur"),a=this._createElement("feBlend");t=t||{width:"200%",height:"200%"},t.id="filter"+i;for(var s in t)n.setAttribute(s,t[s]);var r={result:"offOut","in":"SourceAlpha",dx:"2",dy:"2"},l={result:"blurOut","in":"offOut",stdDeviation:"2"},h={"in":"SourceGraphic",in2:"blurOut",mode:"lighten"};for(var s in r)e.setAttribute(s,r[s]);for(var s in l)o.setAttribute(s,l[s]);for(var s in h)a.setAttribute(s,h[s]);n.appendChild(e),n.appendChild(o),n.appendChild(a),this._dropShadow=n,this._defs.appendChild(n)},_updateStyle:function(){this.__updateStyle.call(this),this.options.stroke&&(this.options.lineCap&&this._path.setAttribute("stroke-linecap",this.options.lineCap),this.options.lineJoin&&this._path.setAttribute("stroke-linejoin",this.options.lineJoin)),this.options.gradient?(this._createGradient(this.options.gradient),this._path.setAttribute("fill","url(#"+this._gradient.getAttribute("id")+")")):this.options.fill||this._path.setAttribute("fill","none"),this.options.dropShadow?(this._createDropShadow(),this._path.setAttribute("filter","url(#"+this._dropShadow.getAttribute("id")+")")):this._path.removeAttribute("filter")}};L.Path.include(PathFunctions),L.Polygon.include(PathFunctions),L.Polyline.include(PathFunctions),L.CircleMarker.include(PathFunctions),L.MapMarker=L.Path.extend({initialize:function(t,i){L.Path.prototype.initialize.call(this,i),this._latlng=t},options:{fill:!0,fillOpacity:1,opacity:1,radius:15,innerRadius:5,position:{x:0,y:0},rotation:0,numberOfSides:50,color:"#000000",fillColor:"#0000FF",weight:1,gradient:!0,dropShadow:!0},setLatLng:function(t){return this._latlng=t,this.redraw()},projectLatlngs:function(){this._point=this._map.latLngToLayerPoint(this._latlng),this._points=this._getPoints(),this.options.innerRadius&&(this._innerPoints=this._getPoints(!0).reverse())},getBounds:function(){var t=this._map,i=3*this.options.radius,n=t.project(this._latlng),e=new L.Point(n.x-this.options.radius,n.y),o=new L.Point(n.x+this.options.radius,n.y-i),a=t.unproject(e),s=t.unproject(o);return new L.LatLngBounds(a,s)},getLatLng:function(){return this._latlng},getPathString:function(){return this._path.setAttribute("shape-rendering","geometricPrecision"),new L.SVGPathBuilder(this._points,this._innerPoints).build(6)},_getPoints:function(t){var i,n,e=t?360:210,o=t?e/Math.max(this.options.numberOfSides,3):e/50,a=t?e+this.options.rotation:e,s=t?this.options.rotation:-30,r=[],l=this.options.radius,h=Math.sqrt(.75),u=function(t){return t*L.LatLng.DEG_TO_RAD},p=this._point;for(t||(r.push(p),r.push(new L.Point(p.x+h*l,p.y-1.5*l)));a>s;)n=u(s),i=this._getPoint(n,l,t),r.push(i),s+=o;return t||r.push(new L.Point(p.x-h*l,p.y-1.5*l)),r},_getPoint:function(t,i,n){var e=i;return i=n?this.options.innerRadius:i,new L.Point(this._point.x+this.options.position.x+i*Math.cos(t),this._point.y-2*e+this.options.position.y-i*Math.sin(t))}}),L.mapMarker=function(t,i){return new L.MapMarker(t,i)},L.RegularPolygonMarker=L.Path.extend({initialize:function(t,i){L.Path.prototype.initialize.call(this,i),this._latlng=t,this.options.numberOfSides=Math.max(this.options.numberOfSides,3)},options:{fill:!0,radiusX:10,radiusY:10,rotation:0,numberOfSides:3,position:{x:0,y:0},maxDegrees:360,gradient:!0,dropShadow:!1},setLatLng:function(t){return this._latlng=t,this.redraw()},projectLatlngs:function(){this._point=this._map.latLngToLayerPoint(this._latlng),this._textPoint=this._point,this._points=this._getPoints(),(this.options.innerRadius||this.options.innerRadiusX&&this.options.innerRadiusY)&&(this._innerPoints=this._getPoints(!0).reverse())},getBounds:function(){var t=this._map,i=this.options.radius||this.options.radiusX,n=this.options.radius||this.options.radiusY,e=i*Math.cos(Math.PI/4),o=n*Math.sin(Math.PI/4),a=t.project(this._latlng),s=new L.Point(a.x-e,a.y+o),r=new L.Point(a.x+e,a.y-o),l=t.unproject(s),h=t.unproject(r);return new L.LatLngBounds(l,h)},getLatLng:function(){return this._latlng},getPathString:function(){return this._path.setAttribute("shape-rendering","geometricPrecision"),new L.SVGPathBuilder(this._points,this._innerPoints).build(6)},_getPoints:function(t){for(var i,n,e=this.options.maxDegrees||360,o=e/Math.max(this.options.numberOfSides,3),a=e+this.options.rotation,s=this.options.rotation,r=[],l=t?this.options.innerRadius||this.options.innerRadiusX:this.options.radius||this.options.radiusX,h=t?this.options.innerRadius||this.options.innerRadiusY:this.options.radius||this.options.radiusY,u=function(t){return t*L.LatLng.DEG_TO_RAD};a>s;)n=u(s),i=this._getPoint(n,l,h),r.push(i),s+=o;return r},_getPoint:function(t,i,n){return new L.Point(this._point.x+this.options.position.x+i*Math.cos(t),this._point.y+this.options.position.y+n*Math.sin(t))}}),L.regularPolygonMarker=function(t,i){return new L.RegularPolygonMarker(t,i)},L.StarMarker=L.RegularPolygonMarker.extend({options:{numberOfPoints:5,rotation:-15,maxDegrees:360,gradient:!0,dropShadow:!0},_getPoints:function(t){for(var i,n,e,o=this.options.maxDegrees||360,a=o/this.options.numberOfPoints,s=o+this.options.rotation,r=this.options.rotation,l=[],h=t?this.options.innerRadius||this.options.innerRadiusX:this.options.radius||this.options.radiusX,u=t?this.options.innerRadius||this.options.innerRadiusY:this.options.radius||this.options.radiusY,p=function(t){return t*L.LatLng.DEG_TO_RAD};s>r;)e=p(r),i=this._getPoint(e,h,u),n=this._getPoint(e+p(a)/2,h/2,u/2),l.push(i),l.push(n),r+=a;return l}}),L.starMarker=function(t,i){return new L.StarMarker(t,i)},L.TriangleMarker=L.RegularPolygonMarker.extend({options:{numberOfSides:3,rotation:30,radius:5}}),L.triangleMarker=function(t,i){return new L.TriangleMarker(t,i)},L.DiamondMarker=L.RegularPolygonMarker.extend({options:{numberOfSides:4,radiusX:5,radiusY:10}}),L.diamondMarker=function(t,i){return new L.DiamondMarker(t,i)},L.SquareMarker=L.RegularPolygonMarker.extend({options:{numberOfSides:4,rotation:45,radius:5}}),L.squareMarker=function(t,i){return new L.SquareMarker(t,i)},L.PentagonMarker=L.RegularPolygonMarker.extend({options:{numberOfSides:5,rotation:-18,radius:5}}),L.pentagonMarker=function(t,i){return new L.PentagonMarker(t,i)},L.HexagonMarker=L.RegularPolygonMarker.extend({options:{numberOfSides:6,rotation:30,radius:5}}),L.hexagonMarker=function(t,i){return new L.HexagonMarker(t,i)},L.OctagonMarker=L.RegularPolygonMarker.extend({options:{numberOfSides:8,rotation:22.5,radius:5}}),L.octagonMarker=function(t,i){return new L.OctagonMarker(t,i)},L.BarMarker=L.Path.extend({initialize:function(t,i){L.Path.prototype.initialize.call(this,i),this._latlng=t},options:{fill:!0,width:2,maxHeight:10,position:{x:0,y:0},weight:1,color:"#000",opacity:1,gradient:!0,dropShadow:!1,lineCap:"square",lineJoin:"miter"},setLatLng:function(t){return this._latlng=t,this.redraw()},projectLatlngs:function(){this._point=this._map.latLngToLayerPoint(this._latlng),this._points=this._getPoints()},getBounds:function(){var t=this._map,i=t.project(this._latlng),n=this.options.width/2,e=new L.Point(i.x-n,i.y),o=new L.Point(i.x+n,i.y-this.options.maxHeight),a=t.unproject(e),s=t.unproject(o);return new L.LatLngBounds(a,s)},getLatLng:function(){return this._latlng},getPathString:function(){return this._path.setAttribute("shape-rendering","crispEdges"),new L.SVGPathBuilder(this._points).build()},_getPoints:function(){var t,i,n,e,o=[],a=this._point.x+this.options.position.x,s=this._point.y+this.options.position.y,r=this.options.width/2,l=this.options.value/this.options.maxValue*this.options.maxHeight;return t=new L.Point(a+r,s),i=new L.Point(a+r,s-l),n=new L.Point(a-r,s-l),e=new L.Point(a-r,s),o=[t,i,n,e]}}),L.barMarker=function(t,i){return new L.BarMarker(t,i)},L.ChartMarker=L.FeatureGroup.extend({initialize:function(t,i){L.Util.setOptions(this,i),this._layers={},this._latlng=t,this._loadComponents()},setLatLng:function(t){return this._latlng=t,this.redraw()},getLatLng:function(){return this._latlng},_loadComponents:function(){},_highlight:function(t){return t.weight&&(t.weight*=2),t},_unhighlight:function(t){return t.weight&&(t.weight/=2),t},_bindMouseEvents:function(t){var i=this,n=this.options.tooltipOptions;t.on("mouseover",function(t){var e,o=this.options,a=o.key,s=o.value,r=t.layerPoint,l=r.x-this._point.x,h=r.y-this._point.y,u=o.iconSize,p=l,c=h,d=5;p=0>l?u.x-l+d:-l-d,c=0>h?u.y-h+d:-h-d,e=new L.Point(p,c);var g={},f=o.displayText?o.displayText(s):s;g[a]={name:o.displayName,value:f};var y=new L.LegendIcon(g,o,{className:"leaflet-div-icon",iconSize:n?n.iconSize:u,iconAnchor:e});o.marker=new L.Marker(i._latlng,{icon:y}),o=i._highlight(o),this.initialize(i._latlng,o),this.redraw(),this.setStyle(o),i.addLayer(o.marker)}),t.on("mouseout",function(){var t=this.options;t=i._unhighlight(t),this.initialize(i._latlng,t),this.redraw(),this.setStyle(t),i.removeLayer(t.marker)})},bindPopup:function(t,i){this.eachLayer(function(n){n.bindPopup(t,i)})},openPopup:function(t){for(var i in this._layers){var n=this._layers[i];t=t||this._latlng,n.openPopup(t);break}},closePopup:function(){for(var t in this._layers){var i=this._layers[t];latlng=latlng||this._latlng,i.closePopup();break}}}),L.BarChartMarker=L.ChartMarker.extend({initialize:function(t,i){L.Util.setOptions(this,i),L.ChartMarker.prototype.initialize.call(this,t,i)},options:{weight:1,opacity:1,color:"#000",fill:!0,position:{x:0,y:0},width:10,offset:0,iconSize:new L.Point(50,40)},_loadComponents:function(){var t,i,n;this.options.rotation,this.options.maxDegrees||360;var e,o=this.options;this.options.radiusX||this.options.radius,this.options.radiusY||this.options.radius;var a,s,r,l=Object.keys(this.options.data),h=l.length,u=this.options.width,p=this.options.offset||0,c=this.options.data,d=this.options.chartOptions;a=-(u*h+p*(h-1))/2+u/2,s=0;for(var g in c)t=c[g],r=d[g],i=r.minValue||0,n=r.maxValue||100,o.fillColor=r.fillColor||this.options.fillColor,o.value=t,o.minValue=i,o.maxValue=n,o.position={x:a,y:s},o.width=u,o.maxHeight=r.maxHeight||10,o.key=g,o.value=t,o.displayName=r.displayName,o.opacity=this.options.opacity||1,o.fillOpacity=this.options.fillOpacity||.7,o.weight=this.options.weight||1,o.color=r.color||this.options.color,o.displayText=r.displayText,e=new L.BarMarker(this._latlng,o),this._bindMouseEvents(e),this.addLayer(e),a+=u+p}}),L.RadialBarMarker=L.Path.extend({initialize:function(t,i){L.Path.prototype.initialize.call(this,i),this._latlng=t},options:{fill:!0,radius:10,rotation:0,numberOfSides:30,position:{x:0,y:0},gradient:!0,dropShadow:!1},setLatLng:function(t){return this._latlng=t,this.redraw()},projectLatlngs:function(){this._point=this._map.latLngToLayerPoint(this._latlng),this._points=this._getPoints()},getBounds:function(){var t=this._map,i=this.options.radiusX||this.options.radius,n=this.options.radiusY||this.options.radius,e=i*Math.cos(Math.PI/4),o=n*Math.sin(Math.PI/4),a=t.project(this._latlng),s=new L.Point(a.x-e,a.y+o),r=new L.Point(a.x+e,a.y-o),l=t.unproject(s),h=t.unproject(r);return new L.LatLngBounds(l,h)},getLatLng:function(){return this._latlng},getPathString:function(){var t=this.options.endAngle-this.options.startAngle,i=t>=180?"1":"0",n=this.options.radiusX||this.options.radius,e=this.options.radiusY||this.options.radius,o="M"+this._points[0].x.toFixed(2)+","+this._points[0].y.toFixed(2)+"A"+n.toFixed(2)+","+e.toFixed(2)+" 0 "+i+",1 "+this._points[1].x.toFixed(2)+","+this._points[1].y.toFixed(2)+"L";return this._innerPoints?(o=o+this._innerPoints[0].x.toFixed(2)+","+this._innerPoints[0].y.toFixed(2),o=o+"A"+(n-this.options.barThickness).toFixed(2)+","+(e-this.options.barThickness).toFixed(2)+" 0 "+i+",0 "+this._innerPoints[1].x.toFixed(2)+","+this._innerPoints[1].y.toFixed(2)+"z"):o=o+this._point.x.toFixed(2)+","+this._point.y.toFixed(2)+"z",L.Browser.vml&&(o=Core.SVG.path(o)),this._path.setAttribute("shape-rendering","geometricPrecision"),o},_getPoints:function(){var t=this.options.endAngle-this.options.startAngle;t/this.options.numberOfSides;var i=this.options.endAngle+this.options.rotation,n=this.options.startAngle+this.options.rotation,e=[],o="radiusX"in this.options?this.options.radiusX:this.options.radius,a="radiusY"in this.options?this.options.radiusY:this.options.radius,s=function(t){return t*L.LatLng.DEG_TO_RAD};360===t&&(i-=.1);var r=s(n),l=s(i);return e.push(this._getPoint(r,o,a)),e.push(this._getPoint(l,o,a)),this.options.barThickness&&(this._innerPoints=[],o-this.options.barThickness,a-this.options.barThickness,this._innerPoints.push(this._getPoint(l,o-this.options.barThickness,a-this.options.barThickness)),this._innerPoints.push(this._getPoint(r,o-this.options.barThickness,a-this.options.barThickness))),e},_getPoint:function(t,i,n){return new L.Point(this._point.x+this.options.position.x+i*Math.cos(t),this._point.y+this.options.position.y+n*Math.sin(t))}}),L.radialBarMarker=function(t,i){return new L.RadialBarMarker(t,i)},L.PieChartMarker=L.ChartMarker.extend({initialize:function(t,i){L.Util.setOptions(this,i),L.ChartMarker.prototype.initialize.call(this,t,i)},options:{weight:1,opacity:1,color:"#000",fill:!0,radius:10,rotation:0,numberOfSides:50,mouseOverExaggeration:1.2,maxDegrees:360,iconSize:new L.Point(50,40)},_highlight:function(t){var i=t.radiusX,n=t.radiusY,e=t.barThickness;return t.oldBarThickness=e,t.oldRadiusX=i,t.oldRadiusY=n,t.radiusX*=t.mouseOverExaggeration,t.radiusY*=t.mouseOverExaggeration,t.barThickness=t.radiusX-i+e,t},_unhighlight:function(t){return t.radiusX=t.oldRadiusX,t.radiusY=t.oldRadiusY,t.barThickness=t.oldBarThickness,t
},_loadComponents:function(){var t,i,n,e,o=0,a=0,s=0,r=this.options.maxDegrees||360,l=this.options.rotation,h=this.options,u=this.options.data,p=this.options.chartOptions,c=function(t,i){var n=0;return t[i]&&(n=parseFloat(t[i])),n};for(e in u)t=c(u,e),o+=t;if(o>0)for(e in u)t=parseFloat(u[e]),n=p[e],s=t/o,a=s*r,h.startAngle=l,h.endAngle=l+a,h.fillColor=n.fillColor,h.color=n.color||"#000",h.radiusX=this.options.radiusX||this.options.radius,h.radiusY=this.options.radiusY||this.options.radius,h.rotation=0,h.key=e,h.value=t,h.displayName=n.displayName,h.displayText=n.displayText,i=new L.RadialBarMarker(this._latlng,h),this._bindMouseEvents(i),l=h.endAngle,this.addLayer(i)}}),L.pieChartMarker=function(t,i){return new L.PieChartMarker(t,i)},L.CoxcombChartMarker=L.PieChartMarker.extend({statics:{SIZE_MODE_RADIUS:"radius",SIZE_MODE_AREA:"area"}}),L.CoxcombChartMarker=L.CoxcombChartMarker.extend({initialize:function(t,i){L.Util.setOptions(this,i),L.PieChartMarker.prototype.initialize.call(this,t,i)},options:{weight:1,opacity:1,color:"#000",fill:!0,radius:10,rotation:0,numberOfSides:50,mouseOverExaggeration:1.2,maxDegrees:360,iconSize:new L.Point(50,40),sizeMode:L.CoxcombChartMarker.SIZE_MODE_AREA},_loadComponents:function(){var t,i,n,e,o,a=0,s=this.options.maxDegrees||360,r=this.options.rotation,l=this.options,h="radiusX"in this.options?this.options.radiusX:this.options.radius,u="radiusY"in this.options?this.options.radiusY:this.options.radius,p=Object.keys(this.options.data),c=p.length,d=this.options.data,g=this.options.chartOptions;a=s/c;for(var f in d){t=parseFloat(d[f]),o=g[f];var i=o.minValue||0,n=o.maxValue;if(this.options.sizeMode===L.CoxcombChartMarker.SIZE_MODE_RADIUS){var y=new L.LinearFunction(new L.Point(i,0),new L.Point(n,h)),_=new L.LinearFunction(new L.Point(i,0),new L.Point(n,u));l.radiusX=y.evaluate(t),l.radiusY=_.evaluate(t)}else{var v=Math.max(h,u),m=Math.PI*Math.pow(v,2)/c,P=new L.LinearFunction(new L.Point(i,0),new L.Point(n,m),{postProcess:function(t){return Math.sqrt(c*t/Math.PI)}});l.radiusX=P.evaluate(t),l.radiusY=l.radiusX}l.startAngle=r,l.endAngle=r+a,l.fillColor=o.fillColor,l.color=o.color||"#000",l.rotation=0,l.key=f,l.value=t,l.displayName=o.displayName,l.displayText=o.displayText,e=new L.RadialBarMarker(this._latlng,l),this._bindMouseEvents(e),r=l.endAngle,this.addLayer(e)}}}),L.coxcombChartMarker=function(t,i){return new L.CoxcombChartMarker(t,i)},L.RadialBarChartMarker=L.ChartMarker.extend({initialize:function(t,i){L.Util.setOptions(this,i),L.ChartMarker.prototype.initialize.call(this,t,i)},options:{weight:1,opacity:1,color:"#000",fill:!0,radius:10,rotation:0,numberOfSides:30,offset:2,barThickness:5,maxDegrees:360,iconSize:new L.Point(50,40)},_loadComponents:function(){var t,i,n,e,o,a=this.options.rotation,s=this.options.maxDegrees||360,r=this.options,l=this.options.radiusX||this.options.radius,h=this.options.radiusY||this.options.radius,u=this.options.data,p=this.options.chartOptions,c=this.options.barThickness||4,d=this.options.offset||2;for(var g in u){t=parseFloat(u[g]),o=p[g],i=o.minValue||0,n=o.maxValue||100;var f=new L.LinearFunction(new L.Point(i,0),new L.Point(n,s));a=f.evaluate(t),r.startAngle=this.options.rotation,r.endAngle=this.options.rotation+a,r.fillColor=o.fillColor,r.radiusX=l,r.radiusY=h,r.barThickness=c,r.rotation=0,r.key=g,r.value=t,r.displayName=o.displayName,r.displayText=o.displayText,r.weight=this.options.weight||1,e=new L.RadialBarMarker(this._latlng,r),this._bindMouseEvents(e),this.addLayer(e),l+=c+d,h+=c+d}}}),L.radialBarChartMarker=function(t,i){return new L.RadialBarChartMarker(t,i)},L.StackedRegularPolygonMarker=L.ChartMarker.extend({options:{iconSize:new L.Point(50,40)},initialize:function(t,i){L.Util.setOptions(this,i),L.ChartMarker.prototype.initialize.call(this,t,i)},_loadComponents:function(){var t,i,n,e,o=0,a=0,s=this.options,r=this.options.data,l=this.options.chartOptions;for(e in r){t=parseFloat(r[e]),n=l[e],minValue=n.minValue||0,maxValue=n.maxValue||100,minRadius=n.minRadius||0,maxRadius=n.maxRadius||10,s.fillColor=n.fillColor||this.options.fillColor,s.value=t,s.minValue=minValue,s.maxValue=maxValue;var h=new L.LinearFunction(new L.Point(minValue,minRadius),new L.Point(maxValue,maxRadius)),u=h.evaluate(t);s.radiusX=o+u,s.radiusY=a+u,s.innerRadiusX=o,s.innerRadiusY=a,s.key=e,s.displayName=n.displayName,s.opacity=this.options.opacity||1,s.fillOpacity=this.options.fillOpacity||.7,s.weight=this.options.weight||1,s.color=n.color||this.options.color,s.displayText=n.displayText,i=new L.RegularPolygonMarker(this._latlng,s),this._bindMouseEvents(i),o=s.radiusX,a=s.radiusY,this.addLayer(i)}}}),L.RadialMeterMarker=L.ChartMarker.extend({initialize:function(t,i){L.Util.setOptions(this,i),L.ChartMarker.prototype.initialize.call(this,t,i)},options:{weight:1,opacity:1,color:"#000",fill:!0,radius:10,rotation:180,numberOfSides:30,offset:2,barThickness:5,maxDegrees:180,iconSize:new L.Point(50,40),backgroundStyle:{fill:!0,fillColor:"#707070",fillOpacity:.2,opacity:.8,color:"#505050"}},_loadComponents:function(){var t,i,n,e,o,a,s=this.options.rotation,r=this.options.maxDegrees||360,l=this.options,h=this.options.radiusX||this.options.radius,u=this.options.radiusY||this.options.radius,p=this.options.data,c=this.options.chartOptions,d=this.options.barThickness||4,g=s,f=this.options.numSegments||10,y=r/f;for(var _ in p){t=parseFloat(p[_]),o=c[_],a=this.options.displayOptions?this.options.displayOptions[_]:{},i=o.minValue||0,n=o.maxValue||100;for(var v=n-i,m=r/v*(t-i),P=s+m,x=s+r,w=new L.LinearFunction(new L.Point(s,i),new L.Point(x,n));P>g;){l.startAngle=g;var M=Math.min(y,P-g);l.endAngle=g+M,l.fillColor=o.fillColor,l.radiusX=h,l.radiusY=u,l.barThickness=d,l.rotation=0,l.key=_,l.value=t,l.displayName=o.displayName,l.displayText=o.displayText;var F=w.evaluate(g+M);for(var b in a)l[b]=a[b].evaluate?a[b].evaluate(F):a[b];e=new L.RadialBarMarker(this._latlng,l),this._bindMouseEvents(e),this.addLayer(e),g+=M}if(this.options.backgroundStyle&&x>g){var M=x-g;l.endAngle=g+M,l.radiusX=h,l.radiusY=u,l.barThickness=d,l.rotation=0,l.key=_,l.value=t,l.displayName=o.displayName,l.displayText=o.displayText,l.fillColor=null,l.fill=!1,l.gradient=!1;for(var S in this.options.backgroundStyle)l[S]=this.options.backgroundStyle[S];var F=w.evaluate(g+M);e=new L.RadialBarMarker(this._latlng,l),this.addLayer(e)}}}}),L.LocationModes={LATLNG:function(t,i){L.Util.getFieldValue(t,this.options.latitudeField),L.Util.getFieldValue(t,this.options.longitudeField);var n=function(i,n){var e=L.Util.getFieldValue(t,i),o=L.Util.getFieldValue(t,n),a=null;if(e&&o){var s=new L.LatLng(e,o);a={location:s,text:[s.lat.toFixed(3),s.lng.toFixed(3)].join(", "),center:s}}return a},e=n(this.options.latitudeField,this.options.longitudeField);if(!e&&this.options.fallbackLocationFields)for(var o,i=0;!e&&this.options.fallbackLocationFields.length>i;)o=this.options.fallbackLocationFields[i],e=n(o.latitudeField,o.longitudeField),i++;return e},GEOHASH:function(t,i){var n,e=this.options.geohashField?L.Util.getFieldValue(t,this.options.geohashField):i,o=decodeGeoHash(e);return o.latitude[2]&&o.longitude[2]&&(n=new L.LatLngBounds(new L.LatLng(o.latitude[0],o.longitude[0]),new L.LatLng(o.latitude[1],o.longitude[1]))),{location:n,text:e,center:n.getCenter()}},COUNTRY:function(t,i){var n,e,o=this.options.codeField?L.Util.getFieldValue(t,this.options.codeField):i,a=L.codeLookup||{},s=L.alpha2Lookup||{},r=L.fips2Lookup||{},l=L.gwNoLookup||{},h=L.countries||{},u=L.countryCentroids||{},p=o.toUpperCase();o=p;var c=p in l;c?o=l[p]||o:2===o.length?o=s[p]||r[p]:3===o.length&&(o=a[p]||o),o?(n=h[o],e=u[o]):console.log("Code not found: "+p);var d=new L.GeoJSON(n);return{location:d,text:L.GeometryUtils.getName(n)||o,center:e}},STATE:function(t,i){var n,e,o=this.options.codeField?L.Util.getFieldValue(t,this.options.codeField):i,a=L.states||{},s=L.stateCentroids||{},r=o.toUpperCase();o=r,n=a[o],e=s[o];var l=new L.GeoJSON(n);return{location:l,text:L.GeometryUtils.getName(n)||o,center:e}},GEOJSON:function(t){var i=this.options.geoJSONField,n=i?L.Util.getFieldValue(t,i):t,e=null;if(n){var o=this,a=function(t,i){return o.recordToLayer(t,i)};e=L.GeometryUtils.getGeoJSONLocation(n,t,this.options.locationTextField,a)}return e},LOOKUP:function(t,i){var n=this.options.codeField?L.Util.getFieldValue(t,this.options.codeField):i;this._lookupIndex=this._lookupIndex||L.GeometryUtils.indexFeatureCollection(this.options.locationLookup,this.options.codeField);var e=this._lookupIndex[n],o=null;if(e){var a=this,s=function(t,i){return a.recordToLayer(t,i)};o=L.GeometryUtils.getGeoJSONLocation(e,t,this.options.locationTextField,s)}return o},CUSTOM:function(t){var i,n=this.options.codeField,e=L.Util.getFieldValue(t,n),o={};if(o[e]=t,this.options.getLocation){var a=this,s=function(t,i){a.locationToLayer(i,o[t])};i=this.options.getLocation(o,n,[e],s)}return i}},L.DataLayer=L.LayerGroup.extend({initialize:function(t,i){L.Util.setOptions(this,i),L.LayerGroup.prototype.initialize.call(this,i),t=t||{},this._boundaryLayer=new L.LayerGroup,this.addLayer(this._boundaryLayer),this.addData(t)},_zoomFunction:function(){var t=this._map,i=this,n=t.getZoom();if(this.options.maxZoom&&n>this.options.maxZoom)this.hiddenLayers=[],this.eachLayer(function(n){i.hiddenLayers.push(n),t.removeLayer(n)});else if(this.hiddenLayers){for(;this.hiddenLayers.length>0;){var e=this.hiddenLayers.pop();t.addLayer(e),this.options.backgroundLayer&&e.bringToBack&&e.bringToBack()}this.hiddenLayers=null}},onAdd:function(t){L.LayerGroup.prototype.onAdd.call(this,t),t.on("zoomend",this._zoomFunction,this)},onRemove:function(t){L.LayerGroup.prototype.onRemove.call(this,t),t.off("zoomend",this._zoomFunction,this)},getBounds:function(){var t;return this.eachLayer(function(i){i.getBounds&&(t?t.extend(i.getBounds()):t=i.getBounds())}),t},options:{recordsField:"features",locationMode:L.LocationModes.LATLNG,latitudeField:"geometry.coordinates.1",longitudeField:"geometry.coordinates.0",displayField:null,displayOptions:null,layerOptions:{numberOfSides:4,radius:10,weight:1,color:"#000"},showLegendTooltips:!0,tooltipOptions:{iconSize:new L.Point(60,50),iconAnchor:new L.Point(-5,50),mouseOverExaggeration:2},setHighlight:function(t){return t.weight=t.weight||1,t.fillOpacity=t.fillOpacity||.5,t.weight*=2,t.fillOpacity/=1.5,t},unsetHighlight:function(t){return t.weight=t.weight||1,t.fillOpacity=t.fillOpacity||.25,t.weight/=2,t.fillOpacity*=1.5,t}},_getLocation:function(t,i){return this.options.locationMode.call(this,t,i)},_processLocation:function(t){var i=t.center;return i},_addBoundary:function(t,i){var n=t.location;if(this.options.includeBoundary){if(n instanceof L.LatLngBounds&&(n=new L.Rectangle(n)),n.setStyle){var e=this.options.boundaryStyle||$.extend(!0,{},i,{fillOpacity:.2,clickable:!1});n.setStyle(e)}this._boundaryLayer.addLayer(n)}},_getLayer:function(t,i,n){return this._addBoundary(t,i),t=this._processLocation(t),this._getMarker(t,i,n)},_getMarker:function(t,i){var n;return t&&(n=i.numberOfSides>=30&&!(i.innerRadius||i.innerRadiusX&&i.innerRadiusY)?new L.CircleMarker(t,i):new L.RegularPolygonMarker(t,i)),n},_preProcessRecords:function(t){return t},_shouldLoadRecord:function(t){return this._includeFunction?this._includeFunction.call(this,t):!0},_loadRecords:function(t){var i,n=this.options.filter||this.options.includeLayer;this._includeFunction=n,t=this._preProcessRecords(t);for(var e in t)if(t.hasOwnProperty(e)){var o=t[e],a=n?n.call(this,o):!0;a&&(i=this._getLocation(o,e),this.locationToLayer(i,o))}},_preloadLocations:function(t){var i=this.options.codeField,n=[],e={};for(var o in t)if(t.hasOwnProperty(o)){var a=t[o],s=L.Util.getFieldValue(a,i);e[s]=a,n.push(s)}if(this.options.getLocation){var r=this,l=function(t,i){r.locationToLayer(i,e[t])};this.options.getLocation(e,i,n,l)}},setDisplayOptions:function(t){return this.options.displayOptions=t,this.reloadData(),this},setDisplayOption:function(t,i){if(this.options.displayOptions=this.options.displayOptions||{},t in this.options.displayOptions){var n=this.options.displayOptions[t];this.options.displayOptions[t]=$.extend({},n,i)}else this.options.displayOptions[t]=i;return this.reloadData(),this},setFilter:function(t){return this.options.filter=t,this.reloadData(),this},setData:function(t){this._data=t,this.reloadData()},reloadData:function(){return this.clearLayers(),this._data&&this.addData(this._data),this},addData:function(t){var i=null!==this.options.recordsField&&this.options.recordsField.length>0?L.Util.getFieldValue(t,this.options.recordsField):t;this.options.locationMode===L.LocationModes.CUSTOM&&this.options.preload?this._preloadLocations(i):this._loadRecords(i),this._data=t},locationToLayer:function(t,i){var n;n=this.recordToLayer(t,i),n&&this.addLayer(n)},_bindMouseEvents:function(t,i,n){var e=this,o=this.options,a=o.setHighlight,s=o.unsetHighlight,r=o.tooltipOptions,l=function(t){var i=t.target,o=this.options||i.options,s=new L.LegendIcon(n,o,{className:r.className||"leaflet-div-icon",iconSize:r.iconSize,iconAnchor:r.iconAnchor}),l=t.latlng||t.target._latlng,h=new L.Marker(l,{icon:s});e.addLayer(h),e.tooltip&&(e.removeLayer(e.tooltip),e.tooltip=null),e.tooltip=h,a&&(o=a(o)),i.setStyle&&i.setStyle(o)},h=function(t){e.tooltip&&e.tooltip.setLatLng(t.latlng)},u=function(t){e.tooltip&&(e.removeLayer(e.tooltip),e.tooltip=null);var i=t.target,n=this.options||i.options;s&&(n=s(n)),i.setStyle&&i.setStyle(n)},p=function(t){t.on({mouseover:l,mouseout:u,mousemove:h})},c=function(t){t.eachLayer?t.eachLayer(function(t){c(t)}):p(t)};c(t)},_getDynamicOptions:function(t){var i=L.Util.extend({},this.options.layerOptions),n=this.options.displayOptions,e={};if(n)for(var o in n){var a,s=n[o],r=L.Util.getFieldValue(t,o),l=s.displayText?s.displayText(r):r;if(e[o]={name:s.displayName,value:l},s.styles)i=L.Util.extend(i,s.styles[r]),s.styles[r]=i;else for(var h in s)a=s[h],i[h]=a.evaluate?a.evaluate(r):a.call?a.call(r):a}return{layerOptions:i,legendDetails:e}},recordToLayer:function(t,i){var n,e=L.Util.extend({},this.options.layerOptions);this.options.displayOptions;var o={},a=!0,s=this.options.filter||this.options.includeLayer;if(s&&(a=s.call(this,i)),a){var r=this._getDynamicOptions(i);e=r.layerOptions,o=r.legendDetails,t&&e&&(e.title=t.text,n=this._getLayer(t,e,i),n&&(this.options.showLegendTooltips&&this._bindMouseEvents(n,e,o),this.options.onEachRecord&&this.options.onEachRecord.call(this,n,i,this)))}return n},getLegend:function(t){return this.options.getLegend?this.options.getLegend.call(this,t):this._getLegend(t)},_getLegendElement:function(t){var i,n,e=$("<i></i>"),o=t.displayProperties,a=t.layerOptions,s=t.ignoreProperties,r=t.displayTextFunction,l=t.index,h=t.numSegments,u=t.segmentWidth,p=t.$minValue,c=t.$maxValue;L.StyleConverter.applySVGStyle(e,a);for(var d in o)if(-1===s.indexOf(d)&&(valueFunction=o[d],valueFunction&&(valueFunction.getBounds||o.minValue&&o.maxValue))){var g=valueFunction.getBounds?valueFunction.getBounds():null,f=g?g[0].x:o.minValue,y=g?g[1].x:o.maxValue,_=new L.LinearFunction(new L.Point(0,f),new L.Point(h,y));i=f,n=y,r&&(i=r(f),n=r(y)),0===l&&(p.html(i),c.html(n));var v=(y-f)/h,m=_.evaluate(l),P=_.evaluate(l+1),x=valueFunction.evaluate?valueFunction.evaluate(m):valueFunction(m),w=valueFunction.evaluate?valueFunction.evaluate(P):valueFunction(P);L.StyleConverter.setCSSProperty(e,d,x),"fillColor"===d&&(e.css("background-image","linear-gradient(left , "+x+" 0%, "+w+" 100%)"),e.css("background-image","-ms-linear-gradient(left , "+x+" 0%, "+w+" 100%)"),e.css("background-image","-moz-linear-gradient(left , "+x+" 0%, "+w+" 100%)"),e.css("background-image","-webkit-linear-gradient(left , "+x+" 0%, "+w+" 100%)")),"color"===d&&(e.css("border-top-color",x),e.css("border-bottom-color",w),e.css("border-left-color",x),e.css("border-right-color",w)),"weight"===d&&(e.css("border-top-width",x),e.css("border-bottom-width",w),e.css("border-left-width",x),e.css("border-right-width",w));var M=v*l+f,F=M+v;r&&valueFunction&&(M=r(M),F=r(F)),e.attr("title",M+" - "+F)}return e.width(u),e},_getLegend:function(t){t=t||this.options.legendOptions||{};var i,n=t.className,e='<div class="legend"></div>',o=$(e),a=t.numSegments||10,s=t.width||100,r=this.options.layerOptions.weight||0,l=s/a-2*r,h=this.options.layerOptions,u=this.options.displayOptions;n&&o.addClass(n),t.title&&o.append("<legend>"+t.title+"</legend>");var p=function(t){return t};for(var c in u){var d=u[c],g=d.displayName||c;i=d.displayText;var f=i?i:p,y=d.styles;if(o.append('<div class="legend-title">'+g+"</div>"),y){var _=new L.CategoryLegend(y);o.append(_.generate())}else for(var v=$('<div class="data-layer-legend"><div class="min-value"></div><div class="scale-bars"></div><div class="max-value"></div></div>'),m=v.find(".min-value"),P=v.find(".max-value"),x=v.find(".scale-bars"),w=["displayName","displayText","minValue","maxValue"],M=0;a>M;++M){var F={displayProperties:d,layerOptions:h,ignoreProperties:w,displayTextFunction:f,index:M,numSegments:a,segmentWidth:l,$minValue:m,$maxValue:P},b=this._getLegendElement(F);x.append(b)}o.append(v)}return o.wrap("<div/>").parent().html()}}),L.dataLayer=function(t,i){return new L.DataLayer(t,i)},L.MapMarkerDataLayer=L.DataLayer.extend({_getMarker:function(t,i){return new L.MapMarker(t,i)}}),L.mapMarkerDataLayer=function(t,i){return new L.MapMarkerDataLayer(t,i)},L.MarkerDataLayer=L.DataLayer.extend({initialize:function(t,i){this._markerMap={},L.DataLayer.prototype.initialize.call(this,t,i)},options:{recordsField:"features",locationMode:L.LocationModes.LATLNG,latitudeField:"latitude",longitudeField:"longitude",layerOptions:{icon:null},showLegendTooltips:!1},_getMarker:function(t,i,n){return this.options.setIcon&&(i.icon=this.options.setIcon.call(this,n,i)),new L.Marker(t,i)},_getLegendElement:function(){},_getLegend:function(){return"<span>No legend available</span>"}}),L.markerDataLayer=function(t,i){return new L.MarkerDataLayer(t,i)},L.PanoramioLayer=L.MarkerDataLayer.extend({statics:{UPLOAD_DATE_FORMAT:"DD MMM YYYY",SIZE_BY_DATE:"date",SIZE_BY_POPULARITY:"popularity",SIZE_BY_NONE:"none",SIZES:{square:[60,60],mini_square:[32,32]},NUM_PHOTOS:50}}),L.PanoramioLayer=L.PanoramioLayer.extend({initialize:function(t){L.MarkerDataLayer.prototype.initialize.call(this,{},t),this._from=0,this._to=L.PanoramioLayer.NUM_PHOTOS,this._calls=[]},options:{recordsField:"photos",latitudeField:"latitude",longitudeField:"longitude",locationMode:L.LocationModes.LATLNG,showLegendTooltips:!1,sizeBy:L.PanoramioLayer.SIZE_BY_DATE,layerOptions:{opacity:1},onEachRecord:function(t,i){L.HTMLUtils.buildTable(i);var n=i.photo_file_url,e=i.photo_title,o=this,a=i.width,s=i.height,r=2e4;t.on("click",function(l){var h=$('<div><img class="photo" onload="this.style.opacity=1" src="'+n+'"/><div class="photo-info"><span>'+e+'</span><a class="photo-link" target="_blank" href="'+i.photo_url+'"><img src="http://www.panoramio.com/img/glass/components/logo_bar/panoramio.png" style="height: 14px;"/></a></div><a class="author-link" target="_blank" href="'+i.owner_url+'">by '+i.owner_name+"</a></div>");h.find(".photo").width(a),h.find(".photo-info").width(a-20);var u=new L.DivIcon({className:"photo-details",html:h.wrap("<div/>").parent().html(),iconAnchor:[a/2,s/2]}),p=new L.Marker(l.target._latlng,{icon:u,zIndexOffset:r});p.on("click",function(t){o.removeLayer(t.target)}),t.viewedImage=p,o.viewedImage=p,o.addLayer(p)}),this.options.onEachPhoto&&this.options.onEachPhoto.call(this,t,i)},setIcon:function(t){var i=L.Util.getFieldValue(t,"photo_title"),n=null;this._sizeFunction&&(n=this._sizeFunction.evaluate(t.index));var e=n?new L.Point(n,n):L.PanoramioLayer.SIZES[this.options.size],o=t.photo_file_url.replace("/medium/","/"+this.options.size+"/"),a=new L.DivIcon({iconSize:e,className:"",html:'<img class="photo" onload="this.style.opacity=1" title="'+i+'" src="'+o+'"/>'});return a},updateInterval:3e5,size:"square",attributionText:'Photos provided by <a href="http://www.panoramio.com"><img src="http://www.panoramio.com/img/glass/components/logo_bar/panoramio.png" style="height: 10px;"/></a>.  Photos provided by <a href="http://www.panoramio.com"><img src="http://www.panoramio.com/img/glass/components/logo_bar/panoramio.png" style="height: 10px;"/></a> are under the copyright of their owners',refreshEvents:"moveend",photoSet:"public"},includes:L.Mixin.Events,onAdd:function(t){L.DataLayer.prototype.onAdd.call(this,t),t.attributionControl&&t.attributionControl.addAttribution(this.options.attributionText);var i=this,n=function(){i._from=0,i._to=L.PanoramioLayer.NUM_PHOTOS,i.fire("requestingPhotos"),i._call&&clearTimeout(i._call);var t=function(){i.requestPhotos()};i._call=setTimeout(t,1e3)};this.requestPhotos(),this._interval=setInterval(n,this.options.updateInterval),this._resetFunction=n,t.on(this.options.refreshEvents,n)},onRemove:function(t){L.DataLayer.prototype.onRemove.call(this,t),t.attributionControl&&t.attributionControl.removeAttribution(this.options.attributionText),this._interval&&(clearInterval(this._interval),this._interval=null),t.off(this.options.refreshEvents,this._resetFunction)},calculateSizeByDate:function(t){for(var i=t.photos,n=[],e=0;i.length>e;++e){var o=i[e],a=moment(o.upload_date,L.PanoramioLayer.UPLOAD_DATE_FORMAT);n.push(a),i[e].index=a}n.sort(function(t,i){return t-i});var s=L.PanoramioLayer.SIZES[this.options.size][0];return this._sizeFunction=new L.LinearFunction([n[0],s/2],[n[n.length-1],s]),t},calculateSizeByPopularity:function(t){for(var i=t.photos,n=0;i.length>n;++n)i[n].index=n;var e=L.PanoramioLayer.SIZES[this.options.size][0];return this._sizeFunction=new L.LinearFunction([0,e/2],[i.length,e]),t},next:function(){this._from=this._to,this._to=this._from+L.PanoramioLayer.NUM_PHOTOS,this.requestPhotos()},previous:function(){this._to=this._from,this._from=this._from-L.PanoramioLayer.NUM_PHOTOS,this.requestPhotos()},requestPhotos:function(){for(var t=this,i=this._map.getBounds(),n=i.getSouthWest(),e=i.getNorthEast();t._calls.length>0;)t._calls.pop().abort();var o=$.ajax({url:"http://www.panoramio.com/map/get_panoramas.php",data:{set:this.options.photoSet,from:t._from,to:t._to,minx:n.lng,miny:n.lat,maxx:e.lng,maxy:e.lat,size:"medium",mapfilter:"true"},type:"GET",dataType:"jsonp",success:function(i){t._count=i.count,moment&&t.options.sizeBy===L.PanoramioLayer.SIZE_BY_DATE?i=t.calculateSizeByDate(i):t.options.sizeBy===L.PanoramioLayer.SIZE_BY_POPULARITY&&(i=t.calculateSizeByPopularity(i)),t.fire("photosAvailable",i),t.clearLayers(),t.addData(i)}});t._calls.push(o)}}),L.panoramioLayer=function(t){return new L.PanoramioLayer(t)},L.GeohashDataLayer=L.DataLayer.extend({initialize:function(t,i){L.DataLayer.prototype.initialize.call(this,t,i)},options:{recordsField:"features",locationMode:L.LocationModes.GEOHASH,geohashField:"geohash",displayField:null,displayOptions:null,layerOptions:{weight:1,color:"#000"}},_getLayer:function(t,i){return new L.Rectangle(t.location,i)}}),L.geohashDataLayer=function(t,i){return new L.GeohashDataLayer(t,i)},L.ChoroplethDataLayer=L.DataLayer.extend({initialize:function(t,i){L.DataLayer.prototype.initialize.call(this,t,i)},options:{recordsField:"features",locationMode:L.LocationModes.COUNTRY,codeField:"ISO",displayField:null,displayOptions:null,layerOptions:{weight:1,color:"#000"},maxZoom:12,backgroundLayer:!0},_getLayer:function(t,i,n){return t.location instanceof L.LatLng&&(t.location=this._getMarker(t.location,i,n)),t.location.setStyle&&t.location.setStyle(i),t.location}}),L.choroplethDataLayer=function(t,i){return new L.ChoroplethDataLayer(t,i)},L.ChartDataLayer=L.DataLayer.extend({options:{showLegendTooltips:!1},initialize:function(t,i){L.DataLayer.prototype.initialize.call(this,t,i)},_getLayer:function(t,i,n){this._addBoundary(t,i),t=this._processLocation(t);var e=this.options.chartOptions;this.options.tooltipOptions;var o={};o=i,o.data={},o.chartOptions=e;for(var a in this.options.chartOptions)o.data[a]=L.Util.getFieldValue(n,a);for(var a in this.options.tooltipOptions)o[a]=this.options.tooltipOptions[a];var s;return t&&(s=this._getMarker(t,o)),s},_getMarker:function(){},_getLegend:function(t){var i=new L.CategoryLegend(this.options.chartOptions);return t=t||this.options.legendOptions,i.generate(t)}}),L.BarChartDataLayer=L.ChartDataLayer.extend({initialize:function(t,i){L.ChartDataLayer.prototype.initialize.call(this,t,i)},_getMarker:function(t,i){return new L.BarChartMarker(t,i)}}),L.barChartDataLayer=function(t,i){return new L.BarChartDataLayer(t,i)},L.RadialBarChartDataLayer=L.ChartDataLayer.extend({initialize:function(t,i){L.ChartDataLayer.prototype.initialize.call(this,t,i)},_getMarker:function(t,i){return new L.RadialBarChartMarker(t,i)}}),L.radialBarChartDataLayer=function(t,i){return new L.RadialBarChartDataLayer(t,i)},L.PieChartDataLayer=L.ChartDataLayer.extend({initialize:function(t,i){L.ChartDataLayer.prototype.initialize.call(this,t,i)},_getMarker:function(t,i){return new L.PieChartMarker(t,i)}}),L.pieChartDataLayer=function(t,i){return new L.PieChartDataLayer(t,i)},L.CoxcombChartDataLayer=L.ChartDataLayer.extend({initialize:function(t,i){L.ChartDataLayer.prototype.initialize.call(this,t,i)},_getMarker:function(t,i){return new L.CoxcombChartMarker(t,i)}}),L.coxcombChartDataLayer=function(t,i){return new L.CoxcombChartDataLayer(t,i)},L.StackedRegularPolygonDataLayer=L.ChartDataLayer.extend({initialize:function(t,i){L.ChartDataLayer.prototype.initialize.call(this,t,i)},_getMarker:function(t,i){return new L.StackedRegularPolygonMarker(t,i)}}),L.stackedRegularPolygonDataLayer=function(t,i){return new L.StackedRegularPolygonDataLayer(t,i)},L.RadialMeterMarkerDataLayer=L.DataLayer.extend({options:{showLegendTooltips:!1},initialize:function(t,i){L.DataLayer.prototype.initialize.call(this,t,i)},_getLayer:function(t,i,n){this._addBoundary(t,i),t=this._processLocation(t);var e=this.options.chartOptions;this.options.tooltipOptions;var o=this.options.displayOptions,a={};a=i,a.data={},a.chartOptions=e,a.displayOptions=o;for(var s in this.options.chartOptions)a.data[s]=L.Util.getFieldValue(n,s);for(var s in this.options.tooltipOptions)a[s]=this.options.tooltipOptions[s];var r;return t&&(r=this._getMarker(t,a)),r},_getMarker:function(t,i){return new L.RadialMeterMarker(t,i)}}),L.radialMeterMarkerDataLayer=function(t,i){return new L.RadialMeterMarkerDataLayer(t,i)},L.CalloutLine=L.Path.extend({statics:{LINESTYLE:{ARC:"arc",ANGLE:"angle",STRAIGHT:"straight"},DIRECTION:{NE:"ne",NW:"nw",SE:"se",SW:"sw"}}}),L.CalloutLine=L.CalloutLine.extend({initialize:function(t,i){L.Util.setOptions(this,i),L.Path.prototype.initialize.call(this,i),this._latlng=t},options:{size:new L.Point(60,30),position:new L.Point(0,0),color:"#FFFFFF",opacity:1,weight:2,fillColor:"#000000",fill:!1,gradient:!1,dropShadow:!0,direction:L.CalloutLine.DIRECTION.NE,lineStyle:L.CalloutLine.LINESTYLE.ANGLE,lineCap:"butt",lineJoin:"miter",arrow:!1},projectLatlngs:function(){this._point=this._map.latLngToLayerPoint(this._latlng),this._points=this._getPoints()},getEndPoint:function(){return this.projectLatlngs(),this._points[this._points.length-1]},_getPathAngle:function(){return new L.SVGPathBuilder(this._points,[],{closePath:!1}).build(6)},_getPathArc:function(){var t=(this.options.direction||L.CalloutLine.DIRECTION.NE).toLowerCase();t[1];var i=t[0],n="n"===i?-1:1,e=this._points[0],o=this._points[this._points.length-1],a=["M",e.x,",",e.y," Q",e.x,",",e.y+n*this.options.size.y," ",o.x,",",o.y];return a.join(" ")},_getPoints:function(){var t=this._point.x+this.options.position.x,i=this._point.y+this.options.position.y,n=this.options.size.x,e=this.options.size.y,o=(this.options.direction||L.CalloutLine.DIRECTION.NE).toLowerCase(),a=[],s=o[1],r=o[0],l="w"===s?-1:1,h="n"===r?-1:1;a.push(new L.Point(t,i));var u=i+h*e,p=n/2,c=Math.atan(e/p);if(this.options.lineStyle===L.CalloutLine.LINESTYLE.ARC?c=Math.atan(Math.pow(e,2)/p):this.options.lineStyle===L.CalloutLine.LINESTYLE.STRAIGHT&&(c=Math.atan(e/n)),this._angle=c,this.options.lineStyle!==L.CalloutLine.LINESTYLE.STRAIGHT){var d=new L.Point(t+l*p,u);a.push(d)}var g=new L.Point(t+l*n,u);return a.push(g),a},getBounds:function(){var t=this._map,i=t.project(this._latlng),n=new L.Point(i.x+this.options.position.x,i.y+this.options.position.y),e=new L.Point(n.x+this.options.size.x,n.y-this.options.size.y),o=t.unproject(n),a=t.unproject(e);return new L.LatLngBounds(o,a)},setLatLng:function(t){this._latlng=t,this.redraw()},getLatLng:function(){return this._latlng},getPathString:function(){this._path.setAttribute("shape-rendering","geometricPrecision");var t=this.options.lineStyle||L.CalloutLine.LINESTYLE.ANGLE,i="";return i+=t===L.CalloutLine.LINESTYLE.ANGLE||t===L.CalloutLine.LINESTYLE.STRAIGHT?this._getPathAngle():this._getPathArc()}}),L.calloutLine=function(t,i){return new L.CalloutLine(t,i)},L.Callout=L.LayerGroup.extend({options:{color:"#FFFFFF",fillColor:"#FFFFFF"},initialize:function(t,i){L.Util.setOptions(this,i),L.LayerGroup.prototype.initialize.call(this,i),this._latlng=t},onAdd:function(t){L.LayerGroup.prototype.onAdd.call(this,t),this.addLayers()},addArrow:function(t,i,n){if(this.options.arrow){var t=L.LatLng.RAD_TO_DEG*t,e=this.options.numberOfSides||3,o=this.options.radius||6,a=180/e,s={se:a+t,sw:180+a-t,nw:180+a+t,ne:a-t},r=s[i],l=new L.RegularPolygonMarker(this._latlng,{position:n,numberOfSides:e,rotation:r,fillColor:this.options.fillColor,color:this.options.color,weight:1,opacity:1,fillOpacity:1,radius:o,lineCap:"butt",lineJoin:"miter"});this.addLayer(l)}},addLine:function(){var t={};for(var i in this.options)"icon"!==i&&(t[i]=this.options[i]);var n=new L.CalloutLine(this._latlng,t);return this.addLayer(n),n},addIcon:function(t,i){var n=this.options.size,e=this.options.icon;e.options.iconAnchor,e.options.iconSize;var o=t[0],a=t[1],s="w"===a?e.options.iconSize.x+n.x-i.x:-1*(n.x+i.x),r="n"===o?e.options.iconSize.y/2+n.y-i.y:-1*(-e.options.iconSize.y/2+n.y+i.y);e.options.iconAnchor=new L.Point(s,r);var l=new L.Marker(this._latlng,{icon:e});this.addLayer(l)},addLayers:function(){var t,i=(this.options.direction||"ne").toLowerCase(),n=this.options.position||new L.Point(0,0);t=this.addLine(),this.addIcon(i,n),this.addArrow(t._angle,i,n)}}),L.callout=function(t,i){return new L.Callout(t,i)},L.FlowLine=L.DataLayer.extend({statics:{LINE_FUNCTION:function(t,i,n){return new L.Polyline([t,i],n)},LINE_FUNCTION_INTERPOLATED:function(t,i,n){var e=this._map.latlngToLayerPoint(t),o=this._map.latlngToLayerPoint(i),a=new L.LinearFunction(e,o),s=Math.ceil(e.distanceTo(o)/n.interpolationOptions.segmentLength);a.samplePoints(s)}}}),L.FlowLine=L.FlowLine.extend({initialize:function(t,i){L.Util.setOptions(this,i),L.DataLayer.prototype.initialize.call(this,t,i)},options:{getLine:L.FlowLine.LINE_FUNCTION},onEachSegment:function(t,i,n){var e={};if(this.options.timeField){var o=L.Util.getFieldValue(t,this.options.timeField),a=L.Util.getFieldValue(i,this.options.timeField),s=this.options.timeFormat,r=s?moment(o,s):moment(o),l=s?moment(a,s):moment(a),h=l.valueOf()-r.valueOf();e.time=h}for(var u in this.options.displayOptions){var p=L.Util.getFieldValue(t,u),c=L.Util.getFieldValue(i,u),d=c-p,g=100*(d/p);e[u]={from:p,to:c,change:d,percentChange:g,changeOverTime:d/e.time}}var f=n.getLatLngs(),y=f[0].distanceTo(f[1]);this.options.onEachSegment&&this.options.onEachSegment.call(this,t,i,n,e,y)},_loadRecords:function(t){var i,n=this.options.layerOptions,e=[];for(var o in t)if(t.hasOwnProperty(o)){var a=t[o];if(i=this._getLocation(a,o)){var s,r=this._getLayer(i,n,a),l=!0;if(this.options.includeLayer&&(l=this.options.includeLayer(a)),this._lastRecord&&l){var n=this._getDynamicOptions(this._lastRecord);s=this.options.getLine.call(this,this._lastMarker.getLatLng(),r.getLatLng(),n.layerOptions),this.addLayer(s),this.onEachSegment(this._lastRecord,a,s)}l&&(this._lastRecord=a,this._lastMarker=r)}}for(;e.length>0;)this.addLayer(e.pop())}}),L.flowLine=function(t,i){return new L.FlowLine(t,i)},L.ArcedFlowLine=L.FlowLine.extend({options:{getLine:function(t,i,n){return new L.ArcedPolyline([t,i],n)
}},initialize:function(t,i){L.FlowLine.prototype.initialize.call(this,t,i)}}),L.arcedFlowLine=function(t,i){return new L.ArcedFlowLine(t,i)},L.ArcedPolyline=L.Path.extend({initialize:function(t,i){L.Path.prototype.initialize.call(this,i),this._latlngs=t},options:{distanceToHeight:new L.LinearFunction([0,5],[1e3,200]),color:"#FFFFFF",opacity:1,weight:1,fillColor:"#000000",fill:!1,gradient:!1,dropShadow:!1,optimizeSpeed:!1},projectLatlngs:function(){this._points=[];for(var t=0;this._latlngs.length>t;++t)this._points.push(this._map.latLngToLayerPoint(this._latlngs[t]))},getBounds:function(){var t=this._map,i=t.project(this._latlngs[0]),n=new L.Point(i.x+this.options.offset.x,i.y+this.options.offset.y),e=new L.Point(n.x+this.options.size.x,n.y-this.options.size.y),o=t.unproject(n),a=t.unproject(e);return new L.LatLngBounds(o,a)},setLatLngs:function(t){this._latlngs=t,this.redraw()},getLatLngs:function(){return this._latlngs},drawSegment:function(t,i){var n=Math.sqrt(Math.pow(i.x-t.x,2)+Math.pow(i.y-t.y,2)),e=this.options.distanceToHeight.evaluate(n),o=t.x-i.x;o/Math.abs(o);var a=["M",t.x,",",t.y," C",t.x,",",t.y-e," ",i.x,",",i.y-e," ",i.x,",",i.y];return a.join(" ")},getPathString:function(){this.options.optimizeSpeed&&this._path.setAttribute("shape-rendering","optimizeSpeed");for(var t=[],i=0;this._points.length-1>i;++i)t.push(this.drawSegment(this._points[i],this._points[i+1]));return t.join("")}}),L.arcedPolyline=function(t,i){return new L.ArcedPolyline(t,i)},L.Control.Legend=L.Control.extend({options:{position:"bottomright",autoAdd:!0},onAdd:function(t){var i="leaflet-control-legend",n=L.DomUtil.create("div",i),e=this;return this.options.autoAdd&&(t.on("layeradd",function(t){var i=t.layer;e.addLayer(i)}),t.on("layerremove",function(t){var i=t.layer;e.removeLayer(i)})),$(n).on("mouseover mouseout",function(){$(this).toggleClass("larger")}),L.DomEvent.addListener(n,"click",L.DomEvent.stopPropagation).addListener(n,"click",L.DomEvent.preventDefault),n},clear:function(){$(this._container).empty()},toggleSize:function(){$(this._container).toggleClass("larger","slow")},addLayer:function(t){var i=L.Util.stamp(t);t.getLegend&&this.addLegend(i,t.getLegend())},removeLayer:function(t){var i=L.Util.stamp(t);t.getLegend&&$(this._container).find("#"+i).remove()},addLegend:function(t,i){var n=$(this._container),e=$(i),o=n.find("#"+t);0===o.size()?n.append('<div id="'+t+'">'+i+"</div>"):o.find("div.legend").replaceWith(e)}}),L.control.legend=function(t){return new L.Control.Legend(t)};